import { defineComponent as Dt, ref as Ue, onMounted as ma, onUnmounted as ya, computed as Et, watch as Ot, toRefs as ga, openBlock as xt, createElementBlock as Rt, createElementVNode as tt, normalizeStyle as wa, withDirectives as ba, vShow as Ca, renderSlot as $r, withModifiers as rt } from "vue";
var Sr = (n, i, a) => {
  if (!i.has(n))
    throw TypeError("Cannot " + a);
}, _a = (n, i, a) => (Sr(n, i, "read from private field"), a ? a.call(n) : i.get(n)), $a = (n, i, a) => {
  if (i.has(n))
    throw TypeError("Cannot add the same private member more than once");
  i instanceof WeakSet ? i.add(n) : i.set(n, a);
}, Sa = (n, i, a, c) => (Sr(n, i, "write to private field"), c ? c.call(n, a) : i.set(n, a), a);
const vr = [
  "aztec",
  "code_128",
  "code_39",
  "code_93",
  "codabar",
  "data_matrix",
  "ean_13",
  "ean_8",
  "itf",
  "pdf417",
  "qr_code",
  "upc_a",
  "upc_e",
  "unknown"
];
function Pa(n) {
  if (Pr(n))
    return {
      width: n.naturalWidth,
      height: n.naturalHeight
    };
  if (Tr(n))
    return {
      width: n.width.baseVal.value,
      height: n.height.baseVal.value
    };
  if (Er(n))
    return {
      width: n.videoWidth,
      height: n.videoHeight
    };
  if (Ta(n))
    return {
      width: n.width,
      height: n.height
    };
  if (Or(n))
    return {
      width: n.width,
      height: n.height
    };
  if (Ea(n))
    return {
      width: n.width,
      height: n.height
    };
  if (Mr(n))
    return {
      width: n.displayWidth,
      height: n.displayHeight
    };
  throw new TypeError(
    "The provided value is not of type '(Blob or HTMLCanvasElement or HTMLImageElement or HTMLVideoElement or ImageBitmap or ImageData or OffscreenCanvas or SVGImageElement or VideoFrame)'."
  );
}
function Pr(n) {
  try {
    return n instanceof HTMLImageElement;
  } catch (i) {
    return !1;
  }
}
function Tr(n) {
  try {
    return n instanceof SVGImageElement;
  } catch (i) {
    return !1;
  }
}
function Er(n) {
  try {
    return n instanceof HTMLVideoElement;
  } catch (i) {
    return !1;
  }
}
function Ta(n) {
  try {
    return n instanceof HTMLCanvasElement;
  } catch (i) {
    return !1;
  }
}
function Or(n) {
  try {
    return n instanceof ImageBitmap;
  } catch (i) {
    return !1;
  }
}
function Ea(n) {
  try {
    return n instanceof OffscreenCanvas;
  } catch (i) {
    return !1;
  }
}
function Mr(n) {
  try {
    return n instanceof VideoFrame;
  } catch (i) {
    return !1;
  }
}
function Oa(n) {
  try {
    return n instanceof Blob;
  } catch (i) {
    return !1;
  }
}
function Ma(n) {
  try {
    return n instanceof ImageData;
  } catch (i) {
    return !1;
  }
}
function Aa(n, i) {
  try {
    const a = new OffscreenCanvas(n, i);
    if (a.getContext("2d") instanceof OffscreenCanvasRenderingContext2D)
      return a;
    throw void 0;
  } catch (a) {
    const c = document.createElement("canvas");
    return c.width = n, c.height = i, c;
  }
}
async function Ar(n) {
  if (Pr(n) && !await Ra(n))
    throw new DOMException(
      "Failed to load or decode HTMLImageElement.",
      "InvalidStateError"
    );
  if (Tr(n) && !await ka(n))
    throw new DOMException(
      "Failed to load or decode SVGImageElement.",
      "InvalidStateError"
    );
  if (Mr(n) && Fa(n))
    throw new DOMException("VideoFrame is closed.", "InvalidStateError");
  if (Er(n) && (n.readyState === 0 || n.readyState === 1))
    throw new DOMException("Invalid element or state.", "InvalidStateError");
  if (Or(n) && Ua(n))
    throw new DOMException(
      "The image source is detached.",
      "InvalidStateError"
    );
  const { width: i, height: a } = Pa(n);
  if (i === 0 || a === 0)
    return null;
  const c = Aa(i, a).getContext("2d");
  c.drawImage(n, 0, 0);
  try {
    return c.getImageData(0, 0, i, a);
  } catch (d) {
    throw new DOMException("Source would taint origin.", "SecurityError");
  }
}
async function Da(n) {
  let i;
  try {
    i = await createImageBitmap(n);
  } catch (a) {
    throw new DOMException(
      "Failed to load or decode Blob.",
      "InvalidStateError"
    );
  }
  return await Ar(i);
}
async function xa(n) {
  if (Oa(n))
    return await Da(n);
  if (Ma(n)) {
    if (Ia(n))
      throw new DOMException(
        "The image data has been detached.",
        "InvalidStateError"
      );
    return n;
  }
  return await Ar(n);
}
async function Ra(n) {
  try {
    return await n.decode(), !0;
  } catch (i) {
    return !1;
  }
}
async function ka(n) {
  var i;
  try {
    return await ((i = n.decode) == null ? void 0 : i.call(n)), !0;
  } catch (a) {
    return !1;
  }
}
function Fa(n) {
  return n.format === null;
}
function Ia(n) {
  return n.data.buffer.byteLength === 0;
}
function Ua(n) {
  return n.width === 0 && n.height === 0;
}
function mr(n, i) {
  return n instanceof DOMException ? new DOMException(`${i}: ${n.message}`, n.name) : n instanceof Error ? new n.constructor(`${i}: ${n.message}`) : new Error(`${i}: ${n}`);
}
const yr = (n) => {
  let i;
  const a = /* @__PURE__ */ new Set(), c = (v, w) => {
    const C = typeof v == "function" ? v(i) : v;
    if (!Object.is(C, i)) {
      const y = i;
      i = w ?? typeof C != "object" ? C : Object.assign({}, i, C), a.forEach((_) => _(i, y));
    }
  }, d = () => i, h = { setState: c, getState: d, subscribe: (v) => (a.add(v), () => a.delete(v)), destroy: () => {
    a.clear();
  } };
  return i = n(c, d, h), h;
}, ja = (n) => n ? yr(n) : yr, Wa = {
  locateFile: (n, i) => {
    var a;
    const c = (a = n.match(/_(.+?)\.wasm$/)) == null ? void 0 : a[1];
    return c ? `https://cdn.jsdelivr.net/npm/@sec-ant/zxing-wasm@2.1.3/dist/${c}/${n}` : i + n;
  }
}, Se = ja()(() => ({
  zxingModuleWeakMap: /* @__PURE__ */ new WeakMap(),
  zxingModuleOverrides: Wa
}));
function ji(n) {
  Se.setState({
    zxingModuleOverrides: n
  });
}
function Dr(n, i = Se.getState().zxingModuleOverrides) {
  const { zxingModuleWeakMap: a } = Se.getState(), c = a.get(
    n
  );
  if (c && Object.is(i, Se.getState().zxingModuleOverrides))
    return c;
  {
    Se.setState({
      zxingModuleOverrides: i
    });
    const d = n(i);
    return a.set(n, d), d;
  }
}
const gr = [
  "Aztec",
  "Codabar",
  "Code128",
  "Code39",
  "Code93",
  "DataBar",
  "DataBarExpanded",
  "DataMatrix",
  "EAN-13",
  "EAN-8",
  "ITF",
  "Linear-Codes",
  "Matrix-Codes",
  "MaxiCode",
  "MicroQRCode",
  "None",
  "PDF417",
  "QRCode",
  "UPC-A",
  "UPC-E"
], de = {
  tryHarder: !0,
  formats: [],
  maxSymbols: 255
};
async function La(n, {
  tryHarder: i = de.tryHarder,
  formats: a = de.formats,
  maxSymbols: c = de.maxSymbols
} = de, d) {
  const h = await Dr(
    d,
    Se.getState().zxingModuleOverrides
  ), {
    data: v,
    width: w,
    height: C,
    data: { byteLength: y }
  } = n, _ = h._malloc(y);
  h.HEAP8.set(v, _);
  const S = h.readBarcodesFromPixmap(
    _,
    w,
    C,
    i,
    Ha(a),
    c
  );
  h._free(_);
  const $ = [];
  for (let j = 0; j < S.size(); ++j) {
    const U = S.get(j);
    $.push({
      ...U,
      format: Va(U.format)
    });
  }
  return $;
}
function Ha(n) {
  return n.join("|");
}
function Va(n) {
  const i = wr(n);
  let a = 0, c = gr.length - 1;
  for (; a <= c; ) {
    const d = Math.floor((a + c) / 2), h = gr[d], v = wr(h);
    if (v === i)
      return h;
    v < i ? a = d + 1 : c = d - 1;
  }
  return "None";
}
function wr(n) {
  return n.toLowerCase().replace(/_-\[\]/g, "");
}
var xr = (() => {
  var n = import.meta.url;
  return function(i = {}) {
    var a = i, c, d;
    a.ready = new Promise((e, t) => {
      c = e, d = t;
    });
    var h = Object.assign({}, a), v = "./this.program", w = typeof window == "object", C = typeof importScripts == "function";
    typeof process == "object" && typeof process.versions == "object" && process.versions.node;
    var y = "";
    function _(e) {
      return a.locateFile ? a.locateFile(e, y) : y + e;
    }
    var S;
    (w || C) && (C ? y = self.location.href : typeof document < "u" && document.currentScript && (y = document.currentScript.src), n && (y = n), y.indexOf("blob:") !== 0 ? y = y.substr(0, y.replace(/[?#].*/, "").lastIndexOf("/") + 1) : y = "", C && (S = (e) => {
      var t = new XMLHttpRequest();
      return t.open("GET", e, !1), t.responseType = "arraybuffer", t.send(null), new Uint8Array(t.response);
    })), a.print || console.log.bind(console);
    var $ = a.printErr || console.error.bind(console);
    Object.assign(a, h), h = null, a.arguments && a.arguments, a.thisProgram && (v = a.thisProgram), a.quit && a.quit;
    var j;
    a.wasmBinary && (j = a.wasmBinary), a.noExitRuntime, typeof WebAssembly != "object" && Ce("no native wasm support detected");
    var U, O, z = !1, M, A, B, ee, W, L, be, Te;
    function Ee() {
      var e = U.buffer;
      a.HEAP8 = M = new Int8Array(e), a.HEAP16 = B = new Int16Array(e), a.HEAP32 = W = new Int32Array(e), a.HEAPU8 = A = new Uint8Array(e), a.HEAPU16 = ee = new Uint16Array(e), a.HEAPU32 = L = new Uint32Array(e), a.HEAPF32 = be = new Float32Array(e), a.HEAPF64 = Te = new Float64Array(e);
    }
    var Oe, je = [], We = [], Le = [];
    function ut() {
      if (a.preRun)
        for (typeof a.preRun == "function" && (a.preRun = [a.preRun]); a.preRun.length; )
          ct(a.preRun.shift());
      ht(je);
    }
    function Me() {
      ht(We);
    }
    function He() {
      if (a.postRun)
        for (typeof a.postRun == "function" && (a.postRun = [a.postRun]); a.postRun.length; )
          ue(a.postRun.shift());
      ht(Le);
    }
    function ct(e) {
      je.unshift(e);
    }
    function lt(e) {
      We.unshift(e);
    }
    function ue(e) {
      Le.unshift(e);
    }
    var J = 0, ve = null;
    function ft(e) {
      J++, a.monitorRunDependencies && a.monitorRunDependencies(J);
    }
    function dt(e) {
      if (J--, a.monitorRunDependencies && a.monitorRunDependencies(J), J == 0 && ve) {
        var t = ve;
        ve = null, t();
      }
    }
    function Ce(e) {
      a.onAbort && a.onAbort(e), e = "Aborted(" + e + ")", $(e), z = !0, e += ". Build with -sASSERTIONS for more info.";
      var t = new WebAssembly.RuntimeError(e);
      throw d(t), t;
    }
    var pt = "data:application/octet-stream;base64,";
    function Ve(e) {
      return e.startsWith(pt);
    }
    var me;
    a.locateFile ? (me = "zxing_reader.wasm", Ve(me) || (me = _(me))) : me = new URL("/reader/zxing_reader.wasm", self.location).href;
    function kt(e) {
      if (e == me && j)
        return new Uint8Array(j);
      if (S)
        return S(e);
      throw "both async and sync fetching of the wasm failed";
    }
    function qr(e) {
      return !j && (w || C) && typeof fetch == "function" ? fetch(e, { credentials: "same-origin" }).then((t) => {
        if (!t.ok)
          throw "failed to load wasm binary file at '" + e + "'";
        return t.arrayBuffer();
      }).catch(() => kt(e)) : Promise.resolve().then(() => kt(e));
    }
    function Ft(e, t, r) {
      return qr(e).then((o) => WebAssembly.instantiate(o, t)).then((o) => o).then(r, (o) => {
        $("failed to asynchronously prepare wasm: " + o), Ce(o);
      });
    }
    function Yr(e, t, r, o) {
      return !e && typeof WebAssembly.instantiateStreaming == "function" && !Ve(t) && typeof fetch == "function" ? fetch(t, { credentials: "same-origin" }).then((s) => {
        var u = WebAssembly.instantiateStreaming(s, r);
        return u.then(o, function(l) {
          return $("wasm streaming compile failed: " + l), $("falling back to ArrayBuffer instantiation"), Ft(t, r, o);
        });
      }) : Ft(t, r, o);
    }
    function Jr() {
      var e = { a: Uo };
      function t(o, s) {
        var u = o.exports;
        return O = u, U = O.qa, Ee(), Oe = O.ua, lt(O.ra), dt(), u;
      }
      ft();
      function r(o) {
        t(o.instance);
      }
      if (a.instantiateWasm)
        try {
          return a.instantiateWasm(e, t);
        } catch (o) {
          $("Module.instantiateWasm callback failed with error: " + o), d(o);
        }
      return Yr(j, me, e, r).catch(d), {};
    }
    var ht = (e) => {
      for (; e.length > 0; )
        e.shift()(a);
    }, ze = [], Be = 0;
    function Qr(e) {
      var t = new Ge(e);
      return t.get_caught() || (t.set_caught(!0), Be--), t.set_rethrown(!1), ze.push(t), cr(t.excPtr), t.get_exception_ptr();
    }
    var re = 0;
    function Xr() {
      D(0, 0);
      var e = ze.pop();
      ur(e.excPtr), re = 0;
    }
    function Ge(e) {
      this.excPtr = e, this.ptr = e - 24, this.set_type = function(t) {
        L[this.ptr + 4 >> 2] = t;
      }, this.get_type = function() {
        return L[this.ptr + 4 >> 2];
      }, this.set_destructor = function(t) {
        L[this.ptr + 8 >> 2] = t;
      }, this.get_destructor = function() {
        return L[this.ptr + 8 >> 2];
      }, this.set_caught = function(t) {
        t = t ? 1 : 0, M[this.ptr + 12 >> 0] = t;
      }, this.get_caught = function() {
        return M[this.ptr + 12 >> 0] != 0;
      }, this.set_rethrown = function(t) {
        t = t ? 1 : 0, M[this.ptr + 13 >> 0] = t;
      }, this.get_rethrown = function() {
        return M[this.ptr + 13 >> 0] != 0;
      }, this.init = function(t, r) {
        this.set_adjusted_ptr(0), this.set_type(t), this.set_destructor(r);
      }, this.set_adjusted_ptr = function(t) {
        L[this.ptr + 16 >> 2] = t;
      }, this.get_adjusted_ptr = function() {
        return L[this.ptr + 16 >> 2];
      }, this.get_exception_ptr = function() {
        var t = fr(this.get_type());
        if (t)
          return L[this.excPtr >> 2];
        var r = this.get_adjusted_ptr();
        return r !== 0 ? r : this.excPtr;
      };
    }
    function Zr(e) {
      throw re || (re = e), re;
    }
    var vt = (e) => {
      var t = re;
      if (!t)
        return Ie(0), 0;
      var r = new Ge(t);
      r.set_adjusted_ptr(t);
      var o = r.get_type();
      if (!o)
        return Ie(0), t;
      for (var s in e) {
        var u = e[s];
        if (u === 0 || u === o)
          break;
        var l = r.ptr + 16;
        if (lr(u, o, l))
          return Ie(u), t;
      }
      return Ie(o), t;
    }, Kr = () => vt([]), en = (e) => vt([e]), tn = (e, t) => vt([e, t]);
    function rn(e) {
      var t = new Ge(e).get_exception_ptr();
      return t;
    }
    function nn() {
      var e = ze.pop();
      e || Ce("no exception to throw");
      var t = e.excPtr;
      throw e.get_rethrown() || (ze.push(e), e.set_rethrown(!0), e.set_caught(!1), Be++), re = t, re;
    }
    function on(e, t, r) {
      var o = new Ge(e);
      throw o.init(t, r), re = e, Be++, re;
    }
    function an() {
      return Be;
    }
    var Ne = {};
    function It(e) {
      for (; e.length; ) {
        var t = e.pop(), r = e.pop();
        r(t);
      }
    }
    function Ae(e) {
      return this.fromWireType(W[e >> 2]);
    }
    var _e = {}, ye = {}, qe = {}, Ut = void 0;
    function Ye(e) {
      throw new Ut(e);
    }
    function ge(e, t, r) {
      e.forEach(function(f) {
        qe[f] = t;
      });
      function o(f) {
        var p = r(f);
        p.length !== e.length && Ye("Mismatched type converter count");
        for (var m = 0; m < e.length; ++m)
          ne(e[m], p[m]);
      }
      var s = new Array(t.length), u = [], l = 0;
      t.forEach((f, p) => {
        ye.hasOwnProperty(f) ? s[p] = ye[f] : (u.push(f), _e.hasOwnProperty(f) || (_e[f] = []), _e[f].push(() => {
          s[p] = ye[f], ++l, l === u.length && o(s);
        }));
      }), u.length === 0 && o(s);
    }
    var sn = function(e) {
      var t = Ne[e];
      delete Ne[e];
      var r = t.rawConstructor, o = t.rawDestructor, s = t.fields, u = s.map((l) => l.getterReturnType).concat(s.map((l) => l.setterArgumentType));
      ge([e], u, (l) => {
        var f = {};
        return s.forEach((p, m) => {
          var b = p.fieldName, T = l[m], E = p.getter, k = p.getterContext, H = l[m + s.length], q = p.setter, V = p.setterContext;
          f[b] = { read: (Y) => T.fromWireType(E(k, Y)), write: (Y, g) => {
            var P = [];
            q(V, Y, H.toWireType(P, g)), It(P);
          } };
        }), [{ name: t.name, fromWireType: function(p) {
          var m = {};
          for (var b in f)
            m[b] = f[b].read(p);
          return o(p), m;
        }, toWireType: function(p, m) {
          for (var b in f)
            if (!(b in m))
              throw new TypeError(`Missing field: "${b}"`);
          var T = r();
          for (b in f)
            f[b].write(T, m[b]);
          return p !== null && p.push(o, T), T;
        }, argPackAdvance: 8, readValueFromPointer: Ae, destructorFunction: o }];
      });
    };
    function un(e, t, r, o, s) {
    }
    function mt(e) {
      switch (e) {
        case 1:
          return 0;
        case 2:
          return 1;
        case 4:
          return 2;
        case 8:
          return 3;
        default:
          throw new TypeError(`Unknown type size: ${e}`);
      }
    }
    function cn() {
      for (var e = new Array(256), t = 0; t < 256; ++t)
        e[t] = String.fromCharCode(t);
      jt = e;
    }
    var jt = void 0;
    function Q(e) {
      for (var t = "", r = e; A[r]; )
        t += jt[A[r++]];
      return t;
    }
    var $e = void 0;
    function F(e) {
      throw new $e(e);
    }
    function ln(e, t, r = {}) {
      var o = t.name;
      if (e || F(`type "${o}" must have a positive integer typeid pointer`), ye.hasOwnProperty(e)) {
        if (r.ignoreDuplicateRegistrations)
          return;
        F(`Cannot register type '${o}' twice`);
      }
      if (ye[e] = t, delete qe[e], _e.hasOwnProperty(e)) {
        var s = _e[e];
        delete _e[e], s.forEach((u) => u());
      }
    }
    function ne(e, t, r = {}) {
      if (!("argPackAdvance" in t))
        throw new TypeError("registerType registeredInstance requires argPackAdvance");
      return ln(e, t, r);
    }
    function fn(e, t, r, o, s) {
      var u = mt(r);
      t = Q(t), ne(e, { name: t, fromWireType: function(l) {
        return !!l;
      }, toWireType: function(l, f) {
        return f ? o : s;
      }, argPackAdvance: 8, readValueFromPointer: function(l) {
        var f;
        if (r === 1)
          f = M;
        else if (r === 2)
          f = B;
        else if (r === 4)
          f = W;
        else
          throw new TypeError("Unknown boolean type size: " + t);
        return this.fromWireType(f[l >> u]);
      }, destructorFunction: null });
    }
    function dn(e) {
      if (!(this instanceof ce) || !(e instanceof ce))
        return !1;
      for (var t = this.$$.ptrType.registeredClass, r = this.$$.ptr, o = e.$$.ptrType.registeredClass, s = e.$$.ptr; t.baseClass; )
        r = t.upcast(r), t = t.baseClass;
      for (; o.baseClass; )
        s = o.upcast(s), o = o.baseClass;
      return t === o && r === s;
    }
    function pn(e) {
      return { count: e.count, deleteScheduled: e.deleteScheduled, preservePointerOnDelete: e.preservePointerOnDelete, ptr: e.ptr, ptrType: e.ptrType, smartPtr: e.smartPtr, smartPtrType: e.smartPtrType };
    }
    function yt(e) {
      function t(r) {
        return r.$$.ptrType.registeredClass.name;
      }
      F(t(e) + " instance already deleted");
    }
    var gt = !1;
    function Wt(e) {
    }
    function hn(e) {
      e.smartPtr ? e.smartPtrType.rawDestructor(e.smartPtr) : e.ptrType.registeredClass.rawDestructor(e.ptr);
    }
    function Lt(e) {
      e.count.value -= 1;
      var t = e.count.value === 0;
      t && hn(e);
    }
    function Ht(e, t, r) {
      if (t === r)
        return e;
      if (r.baseClass === void 0)
        return null;
      var o = Ht(e, t, r.baseClass);
      return o === null ? null : r.downcast(o);
    }
    var Vt = {};
    function vn() {
      return Object.keys(Re).length;
    }
    function mn() {
      var e = [];
      for (var t in Re)
        Re.hasOwnProperty(t) && e.push(Re[t]);
      return e;
    }
    var De = [];
    function wt() {
      for (; De.length; ) {
        var e = De.pop();
        e.$$.deleteScheduled = !1, e.delete();
      }
    }
    var xe = void 0;
    function yn(e) {
      xe = e, De.length && xe && xe(wt);
    }
    function gn() {
      a.getInheritedInstanceCount = vn, a.getLiveInheritedInstances = mn, a.flushPendingDeletes = wt, a.setDelayFunction = yn;
    }
    var Re = {};
    function wn(e, t) {
      for (t === void 0 && F("ptr should not be undefined"); e.baseClass; )
        t = e.upcast(t), e = e.baseClass;
      return t;
    }
    function bn(e, t) {
      return t = wn(e, t), Re[t];
    }
    function Je(e, t) {
      (!t.ptrType || !t.ptr) && Ye("makeClassHandle requires ptr and ptrType");
      var r = !!t.smartPtrType, o = !!t.smartPtr;
      return r !== o && Ye("Both smartPtrType and smartPtr must be specified"), t.count = { value: 1 }, ke(Object.create(e, { $$: { value: t } }));
    }
    function Cn(e) {
      var t = this.getPointee(e);
      if (!t)
        return this.destructor(e), null;
      var r = bn(this.registeredClass, t);
      if (r !== void 0) {
        if (r.$$.count.value === 0)
          return r.$$.ptr = t, r.$$.smartPtr = e, r.clone();
        var o = r.clone();
        return this.destructor(e), o;
      }
      function s() {
        return this.isSmartPointer ? Je(this.registeredClass.instancePrototype, { ptrType: this.pointeeType, ptr: t, smartPtrType: this, smartPtr: e }) : Je(this.registeredClass.instancePrototype, { ptrType: this, ptr: e });
      }
      var u = this.registeredClass.getActualType(t), l = Vt[u];
      if (!l)
        return s.call(this);
      var f;
      this.isConst ? f = l.constPointerType : f = l.pointerType;
      var p = Ht(t, this.registeredClass, f.registeredClass);
      return p === null ? s.call(this) : this.isSmartPointer ? Je(f.registeredClass.instancePrototype, { ptrType: f, ptr: p, smartPtrType: this, smartPtr: e }) : Je(f.registeredClass.instancePrototype, { ptrType: f, ptr: p });
    }
    var ke = function(e) {
      return typeof FinalizationRegistry > "u" ? (ke = (t) => t, e) : (gt = new FinalizationRegistry((t) => {
        Lt(t.$$);
      }), ke = (t) => {
        var r = t.$$, o = !!r.smartPtr;
        if (o) {
          var s = { $$: r };
          gt.register(t, s, t);
        }
        return t;
      }, Wt = (t) => gt.unregister(t), ke(e));
    };
    function _n() {
      if (this.$$.ptr || yt(this), this.$$.preservePointerOnDelete)
        return this.$$.count.value += 1, this;
      var e = ke(Object.create(Object.getPrototypeOf(this), { $$: { value: pn(this.$$) } }));
      return e.$$.count.value += 1, e.$$.deleteScheduled = !1, e;
    }
    function $n() {
      this.$$.ptr || yt(this), this.$$.deleteScheduled && !this.$$.preservePointerOnDelete && F("Object already scheduled for deletion"), Wt(this), Lt(this.$$), this.$$.preservePointerOnDelete || (this.$$.smartPtr = void 0, this.$$.ptr = void 0);
    }
    function Sn() {
      return !this.$$.ptr;
    }
    function Pn() {
      return this.$$.ptr || yt(this), this.$$.deleteScheduled && !this.$$.preservePointerOnDelete && F("Object already scheduled for deletion"), De.push(this), De.length === 1 && xe && xe(wt), this.$$.deleteScheduled = !0, this;
    }
    function Tn() {
      ce.prototype.isAliasOf = dn, ce.prototype.clone = _n, ce.prototype.delete = $n, ce.prototype.isDeleted = Sn, ce.prototype.deleteLater = Pn;
    }
    function ce() {
    }
    var En = 48, On = 57;
    function zt(e) {
      if (e === void 0)
        return "_unknown";
      e = e.replace(/[^a-zA-Z0-9_]/g, "$");
      var t = e.charCodeAt(0);
      return t >= En && t <= On ? `_${e}` : e;
    }
    function Bt(e, t) {
      return e = zt(e), { [e]: function() {
        return t.apply(this, arguments);
      } }[e];
    }
    function Gt(e, t, r) {
      if (e[t].overloadTable === void 0) {
        var o = e[t];
        e[t] = function() {
          return e[t].overloadTable.hasOwnProperty(arguments.length) || F(`Function '${r}' called with an invalid number of arguments (${arguments.length}) - expects one of (${e[t].overloadTable})!`), e[t].overloadTable[arguments.length].apply(this, arguments);
        }, e[t].overloadTable = [], e[t].overloadTable[o.argCount] = o;
      }
    }
    function Nt(e, t, r) {
      a.hasOwnProperty(e) ? ((r === void 0 || a[e].overloadTable !== void 0 && a[e].overloadTable[r] !== void 0) && F(`Cannot register public name '${e}' twice`), Gt(a, e, e), a.hasOwnProperty(r) && F(`Cannot register multiple overloads of a function with the same number of arguments (${r})!`), a[e].overloadTable[r] = t) : (a[e] = t, r !== void 0 && (a[e].numArguments = r));
    }
    function Mn(e, t, r, o, s, u, l, f) {
      this.name = e, this.constructor = t, this.instancePrototype = r, this.rawDestructor = o, this.baseClass = s, this.getActualType = u, this.upcast = l, this.downcast = f, this.pureVirtualFunctions = [];
    }
    function bt(e, t, r) {
      for (; t !== r; )
        t.upcast || F(`Expected null or instance of ${r.name}, got an instance of ${t.name}`), e = t.upcast(e), t = t.baseClass;
      return e;
    }
    function An(e, t) {
      if (t === null)
        return this.isReference && F(`null is not a valid ${this.name}`), 0;
      t.$$ || F(`Cannot pass "${$t(t)}" as a ${this.name}`), t.$$.ptr || F(`Cannot pass deleted object as a pointer of type ${this.name}`);
      var r = t.$$.ptrType.registeredClass, o = bt(t.$$.ptr, r, this.registeredClass);
      return o;
    }
    function Dn(e, t) {
      var r;
      if (t === null)
        return this.isReference && F(`null is not a valid ${this.name}`), this.isSmartPointer ? (r = this.rawConstructor(), e !== null && e.push(this.rawDestructor, r), r) : 0;
      t.$$ || F(`Cannot pass "${$t(t)}" as a ${this.name}`), t.$$.ptr || F(`Cannot pass deleted object as a pointer of type ${this.name}`), !this.isConst && t.$$.ptrType.isConst && F(`Cannot convert argument of type ${t.$$.smartPtrType ? t.$$.smartPtrType.name : t.$$.ptrType.name} to parameter type ${this.name}`);
      var o = t.$$.ptrType.registeredClass;
      if (r = bt(t.$$.ptr, o, this.registeredClass), this.isSmartPointer)
        switch (t.$$.smartPtr === void 0 && F("Passing raw pointer to smart pointer is illegal"), this.sharingPolicy) {
          case 0:
            t.$$.smartPtrType === this ? r = t.$$.smartPtr : F(`Cannot convert argument of type ${t.$$.smartPtrType ? t.$$.smartPtrType.name : t.$$.ptrType.name} to parameter type ${this.name}`);
            break;
          case 1:
            r = t.$$.smartPtr;
            break;
          case 2:
            if (t.$$.smartPtrType === this)
              r = t.$$.smartPtr;
            else {
              var s = t.clone();
              r = this.rawShare(r, le.toHandle(function() {
                s.delete();
              })), e !== null && e.push(this.rawDestructor, r);
            }
            break;
          default:
            F("Unsupporting sharing policy");
        }
      return r;
    }
    function xn(e, t) {
      if (t === null)
        return this.isReference && F(`null is not a valid ${this.name}`), 0;
      t.$$ || F(`Cannot pass "${$t(t)}" as a ${this.name}`), t.$$.ptr || F(`Cannot pass deleted object as a pointer of type ${this.name}`), t.$$.ptrType.isConst && F(`Cannot convert argument of type ${t.$$.ptrType.name} to parameter type ${this.name}`);
      var r = t.$$.ptrType.registeredClass, o = bt(t.$$.ptr, r, this.registeredClass);
      return o;
    }
    function Rn(e) {
      return this.rawGetPointee && (e = this.rawGetPointee(e)), e;
    }
    function kn(e) {
      this.rawDestructor && this.rawDestructor(e);
    }
    function Fn(e) {
      e !== null && e.delete();
    }
    function In() {
      oe.prototype.getPointee = Rn, oe.prototype.destructor = kn, oe.prototype.argPackAdvance = 8, oe.prototype.readValueFromPointer = Ae, oe.prototype.deleteObject = Fn, oe.prototype.fromWireType = Cn;
    }
    function oe(e, t, r, o, s, u, l, f, p, m, b) {
      this.name = e, this.registeredClass = t, this.isReference = r, this.isConst = o, this.isSmartPointer = s, this.pointeeType = u, this.sharingPolicy = l, this.rawGetPointee = f, this.rawConstructor = p, this.rawShare = m, this.rawDestructor = b, !s && t.baseClass === void 0 ? o ? (this.toWireType = An, this.destructorFunction = null) : (this.toWireType = xn, this.destructorFunction = null) : this.toWireType = Dn;
    }
    function qt(e, t, r) {
      a.hasOwnProperty(e) || Ye("Replacing nonexistant public symbol"), a[e].overloadTable !== void 0 && r !== void 0 ? a[e].overloadTable[r] = t : (a[e] = t, a[e].argCount = r);
    }
    var Un = (e, t, r) => {
      var o = a["dynCall_" + e];
      return r && r.length ? o.apply(null, [t].concat(r)) : o.call(null, t);
    }, Qe = [], I = (e) => {
      var t = Qe[e];
      return t || (e >= Qe.length && (Qe.length = e + 1), Qe[e] = t = Oe.get(e)), t;
    }, jn = (e, t, r) => {
      if (e.includes("j"))
        return Un(e, t, r);
      var o = I(t).apply(null, r);
      return o;
    }, Wn = (e, t) => {
      var r = [];
      return function() {
        return r.length = 0, Object.assign(r, arguments), jn(e, t, r);
      };
    };
    function K(e, t) {
      e = Q(e);
      function r() {
        return e.includes("j") ? Wn(e, t) : I(t);
      }
      var o = r();
      return typeof o != "function" && F(`unknown function pointer with signature ${e}: ${t}`), o;
    }
    function Ln(e, t) {
      var r = Bt(t, function(o) {
        this.name = t, this.message = o;
        var s = new Error(o).stack;
        s !== void 0 && (this.stack = this.toString() + `
` + s.replace(/^Error(:[^\n]*)?\n/, ""));
      });
      return r.prototype = Object.create(e.prototype), r.prototype.constructor = r, r.prototype.toString = function() {
        return this.message === void 0 ? this.name : `${this.name}: ${this.message}`;
      }, r;
    }
    var Yt = void 0;
    function Jt(e) {
      var t = sr(e), r = Q(t);
      return ae(t), r;
    }
    function Xe(e, t) {
      var r = [], o = {};
      function s(u) {
        if (!o[u] && !ye[u]) {
          if (qe[u]) {
            qe[u].forEach(s);
            return;
          }
          r.push(u), o[u] = !0;
        }
      }
      throw t.forEach(s), new Yt(`${e}: ` + r.map(Jt).join([", "]));
    }
    function Hn(e, t, r, o, s, u, l, f, p, m, b, T, E) {
      b = Q(b), u = K(s, u), f && (f = K(l, f)), m && (m = K(p, m)), E = K(T, E);
      var k = zt(b);
      Nt(k, function() {
        Xe(`Cannot construct ${b} due to unbound types`, [o]);
      }), ge([e, t, r], o ? [o] : [], function(H) {
        H = H[0];
        var q, V;
        o ? (q = H.registeredClass, V = q.instancePrototype) : V = ce.prototype;
        var Y = Bt(k, function() {
          if (Object.getPrototypeOf(this) !== g)
            throw new $e("Use 'new' to construct " + b);
          if (P.constructor_body === void 0)
            throw new $e(b + " has no accessible constructor");
          var et = P.constructor_body[arguments.length];
          if (et === void 0)
            throw new $e(`Tried to invoke ctor of ${b} with invalid number of parameters (${arguments.length}) - expected (${Object.keys(P.constructor_body).toString()}) parameters instead!`);
          return et.apply(this, arguments);
        }), g = Object.create(V, { constructor: { value: Y } });
        Y.prototype = g;
        var P = new Mn(b, Y, g, E, q, u, f, m);
        P.baseClass && (P.baseClass.__derivedClasses === void 0 && (P.baseClass.__derivedClasses = []), P.baseClass.__derivedClasses.push(P));
        var G = new oe(b, P, !0, !1, !1), N = new oe(b + "*", P, !1, !1, !1), we = new oe(b + " const*", P, !1, !0, !1);
        return Vt[e] = { pointerType: N, constPointerType: we }, qt(k, Y), [G, N, we];
      });
    }
    function Ct(e, t) {
      for (var r = [], o = 0; o < e; o++)
        r.push(L[t + o * 4 >> 2]);
      return r;
    }
    function _t(e, t, r, o, s, u) {
      var l = t.length;
      l < 2 && F("argTypes array size mismatch! Must at least get return value and 'this' types!");
      for (var f = t[1] !== null && r !== null, p = !1, m = 1; m < t.length; ++m)
        if (t[m] !== null && t[m].destructorFunction === void 0) {
          p = !0;
          break;
        }
      var b = t[0].name !== "void", T = l - 2, E = new Array(T), k = [], H = [];
      return function() {
        arguments.length !== T && F(`function ${e} called with ${arguments.length} arguments, expected ${T} args!`), H.length = 0;
        var q;
        k.length = f ? 2 : 1, k[0] = s, f && (q = t[1].toWireType(H, this), k[1] = q);
        for (var V = 0; V < T; ++V)
          E[V] = t[V + 2].toWireType(H, arguments[V]), k.push(E[V]);
        var Y = o.apply(null, k);
        function g(P) {
          if (p)
            It(H);
          else
            for (var G = f ? 1 : 2; G < t.length; G++) {
              var N = G === 1 ? q : E[G - 2];
              t[G].destructorFunction !== null && t[G].destructorFunction(N);
            }
          if (b)
            return t[0].fromWireType(P);
        }
        return g(Y);
      };
    }
    function Vn(e, t, r, o, s, u) {
      var l = Ct(t, r);
      s = K(o, s), ge([], [e], function(f) {
        f = f[0];
        var p = `constructor ${f.name}`;
        if (f.registeredClass.constructor_body === void 0 && (f.registeredClass.constructor_body = []), f.registeredClass.constructor_body[t - 1] !== void 0)
          throw new $e(`Cannot register multiple constructors with identical number of parameters (${t - 1}) for class '${f.name}'! Overload resolution is currently only performed using the parameter count, not actual type info!`);
        return f.registeredClass.constructor_body[t - 1] = () => {
          Xe(`Cannot construct ${f.name} due to unbound types`, l);
        }, ge([], l, function(m) {
          return m.splice(1, 0, null), f.registeredClass.constructor_body[t - 1] = _t(p, m, null, s, u), [];
        }), [];
      });
    }
    function zn(e, t, r, o, s, u, l, f, p) {
      var m = Ct(r, o);
      t = Q(t), u = K(s, u), ge([], [e], function(b) {
        b = b[0];
        var T = `${b.name}.${t}`;
        t.startsWith("@@") && (t = Symbol[t.substring(2)]), f && b.registeredClass.pureVirtualFunctions.push(t);
        function E() {
          Xe(`Cannot call ${T} due to unbound types`, m);
        }
        var k = b.registeredClass.instancePrototype, H = k[t];
        return H === void 0 || H.overloadTable === void 0 && H.className !== b.name && H.argCount === r - 2 ? (E.argCount = r - 2, E.className = b.name, k[t] = E) : (Gt(k, t, T), k[t].overloadTable[r - 2] = E), ge([], m, function(q) {
          var V = _t(T, q, b, u, l);
          return k[t].overloadTable === void 0 ? (V.argCount = r - 2, k[t] = V) : k[t].overloadTable[r - 2] = V, [];
        }), [];
      });
    }
    function Bn() {
      Object.assign(Qt.prototype, { get(e) {
        return this.allocated[e];
      }, has(e) {
        return this.allocated[e] !== void 0;
      }, allocate(e) {
        var t = this.freelist.pop() || this.allocated.length;
        return this.allocated[t] = e, t;
      }, free(e) {
        this.allocated[e] = void 0, this.freelist.push(e);
      } });
    }
    function Qt() {
      this.allocated = [void 0], this.freelist = [];
    }
    var Z = new Qt();
    function Xt(e) {
      e >= Z.reserved && --Z.get(e).refcount === 0 && Z.free(e);
    }
    function Gn() {
      for (var e = 0, t = Z.reserved; t < Z.allocated.length; ++t)
        Z.allocated[t] !== void 0 && ++e;
      return e;
    }
    function Nn() {
      Z.allocated.push({ value: void 0 }, { value: null }, { value: !0 }, { value: !1 }), Z.reserved = Z.allocated.length, a.count_emval_handles = Gn;
    }
    var le = { toValue: (e) => (e || F("Cannot use deleted val. handle = " + e), Z.get(e).value), toHandle: (e) => {
      switch (e) {
        case void 0:
          return 1;
        case null:
          return 2;
        case !0:
          return 3;
        case !1:
          return 4;
        default:
          return Z.allocate({ refcount: 1, value: e });
      }
    } };
    function qn(e, t) {
      t = Q(t), ne(e, { name: t, fromWireType: function(r) {
        var o = le.toValue(r);
        return Xt(r), o;
      }, toWireType: function(r, o) {
        return le.toHandle(o);
      }, argPackAdvance: 8, readValueFromPointer: Ae, destructorFunction: null });
    }
    function $t(e) {
      if (e === null)
        return "null";
      var t = typeof e;
      return t === "object" || t === "array" || t === "function" ? e.toString() : "" + e;
    }
    function Yn(e, t) {
      switch (t) {
        case 2:
          return function(r) {
            return this.fromWireType(be[r >> 2]);
          };
        case 3:
          return function(r) {
            return this.fromWireType(Te[r >> 3]);
          };
        default:
          throw new TypeError("Unknown float type: " + e);
      }
    }
    function Jn(e, t, r) {
      var o = mt(r);
      t = Q(t), ne(e, { name: t, fromWireType: function(s) {
        return s;
      }, toWireType: function(s, u) {
        return u;
      }, argPackAdvance: 8, readValueFromPointer: Yn(t, o), destructorFunction: null });
    }
    function Qn(e, t, r, o, s, u, l) {
      var f = Ct(t, r);
      e = Q(e), s = K(o, s), Nt(e, function() {
        Xe(`Cannot call ${e} due to unbound types`, f);
      }, t - 1), ge([], f, function(p) {
        var m = [p[0], null].concat(p.slice(1));
        return qt(e, _t(e, m, null, s, u), t - 1), [];
      });
    }
    function Xn(e, t, r) {
      switch (t) {
        case 0:
          return r ? function(o) {
            return M[o];
          } : function(o) {
            return A[o];
          };
        case 1:
          return r ? function(o) {
            return B[o >> 1];
          } : function(o) {
            return ee[o >> 1];
          };
        case 2:
          return r ? function(o) {
            return W[o >> 2];
          } : function(o) {
            return L[o >> 2];
          };
        default:
          throw new TypeError("Unknown integer type: " + e);
      }
    }
    function Zn(e, t, r, o, s) {
      t = Q(t);
      var u = mt(r), l = (T) => T;
      if (o === 0) {
        var f = 32 - 8 * r;
        l = (T) => T << f >>> f;
      }
      var p = t.includes("unsigned"), m = (T, E) => {
      }, b;
      p ? b = function(T, E) {
        return m(E, this.name), E >>> 0;
      } : b = function(T, E) {
        return m(E, this.name), E;
      }, ne(e, { name: t, fromWireType: l, toWireType: b, argPackAdvance: 8, readValueFromPointer: Xn(t, u, o !== 0), destructorFunction: null });
    }
    function Kn(e, t, r) {
      var o = [Int8Array, Uint8Array, Int16Array, Uint16Array, Int32Array, Uint32Array, Float32Array, Float64Array], s = o[t];
      function u(l) {
        l = l >> 2;
        var f = L, p = f[l], m = f[l + 1];
        return new s(f.buffer, m, p);
      }
      r = Q(r), ne(e, { name: r, fromWireType: u, argPackAdvance: 8, readValueFromPointer: u }, { ignoreDuplicateRegistrations: !0 });
    }
    var Zt = (e, t, r, o) => {
      if (!(o > 0))
        return 0;
      for (var s = r, u = r + o - 1, l = 0; l < e.length; ++l) {
        var f = e.charCodeAt(l);
        if (f >= 55296 && f <= 57343) {
          var p = e.charCodeAt(++l);
          f = 65536 + ((f & 1023) << 10) | p & 1023;
        }
        if (f <= 127) {
          if (r >= u)
            break;
          t[r++] = f;
        } else if (f <= 2047) {
          if (r + 1 >= u)
            break;
          t[r++] = 192 | f >> 6, t[r++] = 128 | f & 63;
        } else if (f <= 65535) {
          if (r + 2 >= u)
            break;
          t[r++] = 224 | f >> 12, t[r++] = 128 | f >> 6 & 63, t[r++] = 128 | f & 63;
        } else {
          if (r + 3 >= u)
            break;
          t[r++] = 240 | f >> 18, t[r++] = 128 | f >> 12 & 63, t[r++] = 128 | f >> 6 & 63, t[r++] = 128 | f & 63;
        }
      }
      return t[r] = 0, r - s;
    }, eo = (e, t, r) => Zt(e, A, t, r), Kt = (e) => {
      for (var t = 0, r = 0; r < e.length; ++r) {
        var o = e.charCodeAt(r);
        o <= 127 ? t++ : o <= 2047 ? t += 2 : o >= 55296 && o <= 57343 ? (t += 4, ++r) : t += 3;
      }
      return t;
    }, er = typeof TextDecoder < "u" ? new TextDecoder("utf8") : void 0, to = (e, t, r) => {
      for (var o = t + r, s = t; e[s] && !(s >= o); )
        ++s;
      if (s - t > 16 && e.buffer && er)
        return er.decode(e.subarray(t, s));
      for (var u = ""; t < s; ) {
        var l = e[t++];
        if (!(l & 128)) {
          u += String.fromCharCode(l);
          continue;
        }
        var f = e[t++] & 63;
        if ((l & 224) == 192) {
          u += String.fromCharCode((l & 31) << 6 | f);
          continue;
        }
        var p = e[t++] & 63;
        if ((l & 240) == 224 ? l = (l & 15) << 12 | f << 6 | p : l = (l & 7) << 18 | f << 12 | p << 6 | e[t++] & 63, l < 65536)
          u += String.fromCharCode(l);
        else {
          var m = l - 65536;
          u += String.fromCharCode(55296 | m >> 10, 56320 | m & 1023);
        }
      }
      return u;
    }, St = (e, t) => e ? to(A, e, t) : "";
    function ro(e, t) {
      t = Q(t);
      var r = t === "std::string";
      ne(e, { name: t, fromWireType: function(o) {
        var s = L[o >> 2], u = o + 4, l;
        if (r)
          for (var f = u, p = 0; p <= s; ++p) {
            var m = u + p;
            if (p == s || A[m] == 0) {
              var b = m - f, T = St(f, b);
              l === void 0 ? l = T : (l += String.fromCharCode(0), l += T), f = m + 1;
            }
          }
        else {
          for (var E = new Array(s), p = 0; p < s; ++p)
            E[p] = String.fromCharCode(A[u + p]);
          l = E.join("");
        }
        return ae(o), l;
      }, toWireType: function(o, s) {
        s instanceof ArrayBuffer && (s = new Uint8Array(s));
        var u, l = typeof s == "string";
        l || s instanceof Uint8Array || s instanceof Uint8ClampedArray || s instanceof Int8Array || F("Cannot pass non-string to std::string"), r && l ? u = Kt(s) : u = s.length;
        var f = Tt(4 + u + 1), p = f + 4;
        if (L[f >> 2] = u, r && l)
          eo(s, p, u + 1);
        else if (l)
          for (var m = 0; m < u; ++m) {
            var b = s.charCodeAt(m);
            b > 255 && (ae(p), F("String has UTF-16 code units that do not fit in 8 bits")), A[p + m] = b;
          }
        else
          for (var m = 0; m < u; ++m)
            A[p + m] = s[m];
        return o !== null && o.push(ae, f), f;
      }, argPackAdvance: 8, readValueFromPointer: Ae, destructorFunction: function(o) {
        ae(o);
      } });
    }
    var tr = typeof TextDecoder < "u" ? new TextDecoder("utf-16le") : void 0, no = (e, t) => {
      for (var r = e, o = r >> 1, s = o + t / 2; !(o >= s) && ee[o]; )
        ++o;
      if (r = o << 1, r - e > 32 && tr)
        return tr.decode(A.subarray(e, r));
      for (var u = "", l = 0; !(l >= t / 2); ++l) {
        var f = B[e + l * 2 >> 1];
        if (f == 0)
          break;
        u += String.fromCharCode(f);
      }
      return u;
    }, oo = (e, t, r) => {
      if (r === void 0 && (r = 2147483647), r < 2)
        return 0;
      r -= 2;
      for (var o = t, s = r < e.length * 2 ? r / 2 : e.length, u = 0; u < s; ++u) {
        var l = e.charCodeAt(u);
        B[t >> 1] = l, t += 2;
      }
      return B[t >> 1] = 0, t - o;
    }, ao = (e) => e.length * 2, io = (e, t) => {
      for (var r = 0, o = ""; !(r >= t / 4); ) {
        var s = W[e + r * 4 >> 2];
        if (s == 0)
          break;
        if (++r, s >= 65536) {
          var u = s - 65536;
          o += String.fromCharCode(55296 | u >> 10, 56320 | u & 1023);
        } else
          o += String.fromCharCode(s);
      }
      return o;
    }, so = (e, t, r) => {
      if (r === void 0 && (r = 2147483647), r < 4)
        return 0;
      for (var o = t, s = o + r - 4, u = 0; u < e.length; ++u) {
        var l = e.charCodeAt(u);
        if (l >= 55296 && l <= 57343) {
          var f = e.charCodeAt(++u);
          l = 65536 + ((l & 1023) << 10) | f & 1023;
        }
        if (W[t >> 2] = l, t += 4, t + 4 > s)
          break;
      }
      return W[t >> 2] = 0, t - o;
    }, uo = (e) => {
      for (var t = 0, r = 0; r < e.length; ++r) {
        var o = e.charCodeAt(r);
        o >= 55296 && o <= 57343 && ++r, t += 4;
      }
      return t;
    }, co = function(e, t, r) {
      r = Q(r);
      var o, s, u, l, f;
      t === 2 ? (o = no, s = oo, l = ao, u = () => ee, f = 1) : t === 4 && (o = io, s = so, l = uo, u = () => L, f = 2), ne(e, { name: r, fromWireType: function(p) {
        for (var m = L[p >> 2], b = u(), T, E = p + 4, k = 0; k <= m; ++k) {
          var H = p + 4 + k * t;
          if (k == m || b[H >> f] == 0) {
            var q = H - E, V = o(E, q);
            T === void 0 ? T = V : (T += String.fromCharCode(0), T += V), E = H + t;
          }
        }
        return ae(p), T;
      }, toWireType: function(p, m) {
        typeof m != "string" && F(`Cannot pass non-string to C++ string type ${r}`);
        var b = l(m), T = Tt(4 + b + t);
        return L[T >> 2] = b >> f, s(m, T + 4, b + t), p !== null && p.push(ae, T), T;
      }, argPackAdvance: 8, readValueFromPointer: Ae, destructorFunction: function(p) {
        ae(p);
      } });
    };
    function lo(e, t, r, o, s, u) {
      Ne[e] = { name: Q(t), rawConstructor: K(r, o), rawDestructor: K(s, u), fields: [] };
    }
    function fo(e, t, r, o, s, u, l, f, p, m) {
      Ne[e].fields.push({ fieldName: Q(t), getterReturnType: r, getter: K(o, s), getterContext: u, setterArgumentType: l, setter: K(f, p), setterContext: m });
    }
    function po(e, t) {
      t = Q(t), ne(e, { isVoid: !0, name: t, argPackAdvance: 0, fromWireType: function() {
      }, toWireType: function(r, o) {
      } });
    }
    var ho = {};
    function vo(e) {
      var t = ho[e];
      return t === void 0 ? Q(e) : t;
    }
    function rr() {
      if (typeof globalThis == "object")
        return globalThis;
      function e(t) {
        t.$$$embind_global$$$ = t;
        var r = typeof $$$embind_global$$$ == "object" && t.$$$embind_global$$$ == t;
        return r || delete t.$$$embind_global$$$, r;
      }
      if (typeof $$$embind_global$$$ == "object" || (typeof global == "object" && e(global) ? $$$embind_global$$$ = global : typeof self == "object" && e(self) && ($$$embind_global$$$ = self), typeof $$$embind_global$$$ == "object"))
        return $$$embind_global$$$;
      throw Error("unable to get global object.");
    }
    function mo(e) {
      return e === 0 ? le.toHandle(rr()) : (e = vo(e), le.toHandle(rr()[e]));
    }
    function yo(e) {
      e > 4 && (Z.get(e).refcount += 1);
    }
    function nr(e, t) {
      var r = ye[e];
      return r === void 0 && F(t + " has unknown type " + Jt(e)), r;
    }
    function go(e) {
      var t = new Array(e + 1);
      return function(r, o, s) {
        t[0] = r;
        for (var u = 0; u < e; ++u) {
          var l = nr(L[o + u * 4 >> 2], "parameter " + u);
          t[u + 1] = l.readValueFromPointer(s), s += l.argPackAdvance;
        }
        var f = new (r.bind.apply(r, t))();
        return le.toHandle(f);
      };
    }
    var or = {};
    function wo(e, t, r, o) {
      e = le.toValue(e);
      var s = or[t];
      return s || (s = go(t), or[t] = s), s(e, r, o);
    }
    function bo(e, t) {
      e = nr(e, "_emval_take_value");
      var r = e.readValueFromPointer(t);
      return le.toHandle(r);
    }
    var Co = () => {
      Ce("");
    }, _o = (e, t, r) => A.copyWithin(e, t, t + r), $o = () => 2147483648, So = (e) => {
      var t = U.buffer, r = e - t.byteLength + 65535 >>> 16;
      try {
        return U.grow(r), Ee(), 1;
      } catch (o) {
      }
    }, Po = (e) => {
      var t = A.length;
      e >>>= 0;
      var r = $o();
      if (e > r)
        return !1;
      for (var o = (p, m) => p + (m - p % m) % m, s = 1; s <= 4; s *= 2) {
        var u = t * (1 + 0.2 / s);
        u = Math.min(u, e + 100663296);
        var l = Math.min(r, o(Math.max(e, u), 65536)), f = So(l);
        if (f)
          return !0;
      }
      return !1;
    }, Pt = {}, To = () => v || "./this.program", Fe = () => {
      if (!Fe.strings) {
        var e = (typeof navigator == "object" && navigator.languages && navigator.languages[0] || "C").replace("-", "_") + ".UTF-8", t = { USER: "web_user", LOGNAME: "web_user", PATH: "/", PWD: "/", HOME: "/home/web_user", LANG: e, _: To() };
        for (var r in Pt)
          Pt[r] === void 0 ? delete t[r] : t[r] = Pt[r];
        var o = [];
        for (var r in t)
          o.push(`${r}=${t[r]}`);
        Fe.strings = o;
      }
      return Fe.strings;
    }, Eo = (e, t) => {
      for (var r = 0; r < e.length; ++r)
        M[t++ >> 0] = e.charCodeAt(r);
      M[t >> 0] = 0;
    }, Oo = (e, t) => {
      var r = 0;
      return Fe().forEach(function(o, s) {
        var u = t + r;
        L[e + s * 4 >> 2] = u, Eo(o, u), r += o.length + 1;
      }), 0;
    }, Mo = (e, t) => {
      var r = Fe();
      L[e >> 2] = r.length;
      var o = 0;
      return r.forEach(function(s) {
        o += s.length + 1;
      }), L[t >> 2] = o, 0;
    };
    function Ao(e) {
      return e;
    }
    var Ze = (e) => e % 4 === 0 && (e % 100 !== 0 || e % 400 === 0), Do = (e, t) => {
      for (var r = 0, o = 0; o <= t; r += e[o++])
        ;
      return r;
    }, ar = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], ir = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31], xo = (e, t) => {
      for (var r = new Date(e.getTime()); t > 0; ) {
        var o = Ze(r.getFullYear()), s = r.getMonth(), u = (o ? ar : ir)[s];
        if (t > u - r.getDate())
          t -= u - r.getDate() + 1, r.setDate(1), s < 11 ? r.setMonth(s + 1) : (r.setMonth(0), r.setFullYear(r.getFullYear() + 1));
        else
          return r.setDate(r.getDate() + t), r;
      }
      return r;
    };
    function Ro(e, t, r) {
      var o = r > 0 ? r : Kt(e) + 1, s = new Array(o), u = Zt(e, s, 0, s.length);
      return t && (s.length = u), s;
    }
    var ko = (e, t) => {
      M.set(e, t);
    }, Fo = (e, t, r, o) => {
      var s = W[o + 40 >> 2], u = { tm_sec: W[o >> 2], tm_min: W[o + 4 >> 2], tm_hour: W[o + 8 >> 2], tm_mday: W[o + 12 >> 2], tm_mon: W[o + 16 >> 2], tm_year: W[o + 20 >> 2], tm_wday: W[o + 24 >> 2], tm_yday: W[o + 28 >> 2], tm_isdst: W[o + 32 >> 2], tm_gmtoff: W[o + 36 >> 2], tm_zone: s ? St(s) : "" }, l = St(r), f = { "%c": "%a %b %d %H:%M:%S %Y", "%D": "%m/%d/%y", "%F": "%Y-%m-%d", "%h": "%b", "%r": "%I:%M:%S %p", "%R": "%H:%M", "%T": "%H:%M:%S", "%x": "%m/%d/%y", "%X": "%H:%M:%S", "%Ec": "%c", "%EC": "%C", "%Ex": "%m/%d/%y", "%EX": "%H:%M:%S", "%Ey": "%y", "%EY": "%Y", "%Od": "%d", "%Oe": "%e", "%OH": "%H", "%OI": "%I", "%Om": "%m", "%OM": "%M", "%OS": "%S", "%Ou": "%u", "%OU": "%U", "%OV": "%V", "%Ow": "%w", "%OW": "%W", "%Oy": "%y" };
      for (var p in f)
        l = l.replace(new RegExp(p, "g"), f[p]);
      var m = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"], b = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
      function T(g, P, G) {
        for (var N = typeof g == "number" ? g.toString() : g || ""; N.length < P; )
          N = G[0] + N;
        return N;
      }
      function E(g, P) {
        return T(g, P, "0");
      }
      function k(g, P) {
        function G(we) {
          return we < 0 ? -1 : we > 0 ? 1 : 0;
        }
        var N;
        return (N = G(g.getFullYear() - P.getFullYear())) === 0 && (N = G(g.getMonth() - P.getMonth())) === 0 && (N = G(g.getDate() - P.getDate())), N;
      }
      function H(g) {
        switch (g.getDay()) {
          case 0:
            return new Date(g.getFullYear() - 1, 11, 29);
          case 1:
            return g;
          case 2:
            return new Date(g.getFullYear(), 0, 3);
          case 3:
            return new Date(g.getFullYear(), 0, 2);
          case 4:
            return new Date(g.getFullYear(), 0, 1);
          case 5:
            return new Date(g.getFullYear() - 1, 11, 31);
          case 6:
            return new Date(g.getFullYear() - 1, 11, 30);
        }
      }
      function q(g) {
        var P = xo(new Date(g.tm_year + 1900, 0, 1), g.tm_yday), G = new Date(P.getFullYear(), 0, 4), N = new Date(P.getFullYear() + 1, 0, 4), we = H(G), et = H(N);
        return k(we, P) <= 0 ? k(et, P) <= 0 ? P.getFullYear() + 1 : P.getFullYear() : P.getFullYear() - 1;
      }
      var V = { "%a": (g) => m[g.tm_wday].substring(0, 3), "%A": (g) => m[g.tm_wday], "%b": (g) => b[g.tm_mon].substring(0, 3), "%B": (g) => b[g.tm_mon], "%C": (g) => {
        var P = g.tm_year + 1900;
        return E(P / 100 | 0, 2);
      }, "%d": (g) => E(g.tm_mday, 2), "%e": (g) => T(g.tm_mday, 2, " "), "%g": (g) => q(g).toString().substring(2), "%G": (g) => q(g), "%H": (g) => E(g.tm_hour, 2), "%I": (g) => {
        var P = g.tm_hour;
        return P == 0 ? P = 12 : P > 12 && (P -= 12), E(P, 2);
      }, "%j": (g) => E(g.tm_mday + Do(Ze(g.tm_year + 1900) ? ar : ir, g.tm_mon - 1), 3), "%m": (g) => E(g.tm_mon + 1, 2), "%M": (g) => E(g.tm_min, 2), "%n": () => `
`, "%p": (g) => g.tm_hour >= 0 && g.tm_hour < 12 ? "AM" : "PM", "%S": (g) => E(g.tm_sec, 2), "%t": () => "	", "%u": (g) => g.tm_wday || 7, "%U": (g) => {
        var P = g.tm_yday + 7 - g.tm_wday;
        return E(Math.floor(P / 7), 2);
      }, "%V": (g) => {
        var P = Math.floor((g.tm_yday + 7 - (g.tm_wday + 6) % 7) / 7);
        if ((g.tm_wday + 371 - g.tm_yday - 2) % 7 <= 2 && P++, P) {
          if (P == 53) {
            var G = (g.tm_wday + 371 - g.tm_yday) % 7;
            G != 4 && (G != 3 || !Ze(g.tm_year)) && (P = 1);
          }
        } else {
          P = 52;
          var N = (g.tm_wday + 7 - g.tm_yday - 1) % 7;
          (N == 4 || N == 5 && Ze(g.tm_year % 400 - 1)) && P++;
        }
        return E(P, 2);
      }, "%w": (g) => g.tm_wday, "%W": (g) => {
        var P = g.tm_yday + 7 - (g.tm_wday + 6) % 7;
        return E(Math.floor(P / 7), 2);
      }, "%y": (g) => (g.tm_year + 1900).toString().substring(2), "%Y": (g) => g.tm_year + 1900, "%z": (g) => {
        var P = g.tm_gmtoff, G = P >= 0;
        return P = Math.abs(P) / 60, P = P / 60 * 100 + P % 60, (G ? "+" : "-") + ("0000" + P).slice(-4);
      }, "%Z": (g) => g.tm_zone, "%%": () => "%" };
      l = l.replace(/%%/g, "\0\0");
      for (var p in V)
        l.includes(p) && (l = l.replace(new RegExp(p, "g"), V[p](u)));
      l = l.replace(/\0\0/g, "%");
      var Y = Ro(l, !1);
      return Y.length > t ? 0 : (ko(Y, e), Y.length - 1);
    }, Io = (e, t, r, o, s) => Fo(e, t, r, o);
    Ut = a.InternalError = class extends Error {
      constructor(e) {
        super(e), this.name = "InternalError";
      }
    }, cn(), $e = a.BindingError = class extends Error {
      constructor(e) {
        super(e), this.name = "BindingError";
      }
    }, Tn(), gn(), In(), Yt = a.UnboundTypeError = Ln(Error, "UnboundTypeError"), Bn(), Nn();
    var Uo = { q: Qr, u: Xr, a: Kr, h: en, l: tn, I: rn, P: nn, n: on, ba: an, d: Zr, oa: sn, Y: un, fa: fn, na: Hn, ma: Vn, D: zn, ea: qn, W: Jn, J: Qn, w: Zn, s: Kn, V: ro, L: co, Q: lo, pa: fo, ga: po, U: Xt, la: mo, R: yo, ia: wo, ka: bo, K: Co, da: _o, ca: Po, $: Oo, aa: Mo, H: ra, T: fa, B: oa, p: Ko, b: jo, C: ta, ha: ia, c: zo, j: Go, i: Ho, x: na, O: ea, v: Xo, G: ua, N: ca, A: aa, F: da, Z: ha, X: va, k: Bo, f: Vo, e: Lo, g: Wo, M: la, m: Qo, o: No, S: qo, t: Jo, ja: Zo, y: sa, r: Yo, E: pa, z: Ao, _: Io };
    Jr();
    var ae = a._free = (e) => (ae = a._free = O.sa)(e), Tt = a._malloc = (e) => (Tt = a._malloc = O.ta)(e), sr = (e) => (sr = O.va)(e);
    a.__embind_initialize_bindings = () => (a.__embind_initialize_bindings = O.wa)();
    var D = (e, t) => (D = O.xa)(e, t), Ie = (e) => (Ie = O.ya)(e), x = () => (x = O.za)(), R = (e) => (R = O.Aa)(e), ur = (e) => (ur = O.Ba)(e), cr = (e) => (cr = O.Ca)(e), lr = (e, t, r) => (lr = O.Da)(e, t, r), fr = (e) => (fr = O.Ea)(e);
    a.dynCall_viijii = (e, t, r, o, s, u, l) => (a.dynCall_viijii = O.Fa)(e, t, r, o, s, u, l);
    var dr = a.dynCall_jiii = (e, t, r, o) => (dr = a.dynCall_jiii = O.Ga)(e, t, r, o), pr = a.dynCall_jiiii = (e, t, r, o, s) => (pr = a.dynCall_jiiii = O.Ha)(e, t, r, o, s);
    a.dynCall_iiiiij = (e, t, r, o, s, u, l) => (a.dynCall_iiiiij = O.Ia)(e, t, r, o, s, u, l), a.dynCall_iiiiijj = (e, t, r, o, s, u, l, f, p) => (a.dynCall_iiiiijj = O.Ja)(e, t, r, o, s, u, l, f, p), a.dynCall_iiiiiijj = (e, t, r, o, s, u, l, f, p, m) => (a.dynCall_iiiiiijj = O.Ka)(e, t, r, o, s, u, l, f, p, m);
    function jo(e, t) {
      var r = x();
      try {
        return I(e)(t);
      } catch (o) {
        if (R(r), o !== o + 0)
          throw o;
        D(1, 0);
      }
    }
    function Wo(e, t, r, o) {
      var s = x();
      try {
        I(e)(t, r, o);
      } catch (u) {
        if (R(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function Lo(e, t, r) {
      var o = x();
      try {
        I(e)(t, r);
      } catch (s) {
        if (R(o), s !== s + 0)
          throw s;
        D(1, 0);
      }
    }
    function Ho(e, t, r, o, s) {
      var u = x();
      try {
        return I(e)(t, r, o, s);
      } catch (l) {
        if (R(u), l !== l + 0)
          throw l;
        D(1, 0);
      }
    }
    function Vo(e, t) {
      var r = x();
      try {
        I(e)(t);
      } catch (o) {
        if (R(r), o !== o + 0)
          throw o;
        D(1, 0);
      }
    }
    function zo(e, t, r) {
      var o = x();
      try {
        return I(e)(t, r);
      } catch (s) {
        if (R(o), s !== s + 0)
          throw s;
        D(1, 0);
      }
    }
    function Bo(e) {
      var t = x();
      try {
        I(e)();
      } catch (r) {
        if (R(t), r !== r + 0)
          throw r;
        D(1, 0);
      }
    }
    function Go(e, t, r, o) {
      var s = x();
      try {
        return I(e)(t, r, o);
      } catch (u) {
        if (R(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function No(e, t, r, o, s, u) {
      var l = x();
      try {
        I(e)(t, r, o, s, u);
      } catch (f) {
        if (R(l), f !== f + 0)
          throw f;
        D(1, 0);
      }
    }
    function qo(e, t, r, o, s, u, l) {
      var f = x();
      try {
        I(e)(t, r, o, s, u, l);
      } catch (p) {
        if (R(f), p !== p + 0)
          throw p;
        D(1, 0);
      }
    }
    function Yo(e, t, r, o, s, u, l, f, p, m, b) {
      var T = x();
      try {
        I(e)(t, r, o, s, u, l, f, p, m, b);
      } catch (E) {
        if (R(T), E !== E + 0)
          throw E;
        D(1, 0);
      }
    }
    function Jo(e, t, r, o, s, u, l, f) {
      var p = x();
      try {
        I(e)(t, r, o, s, u, l, f);
      } catch (m) {
        if (R(p), m !== m + 0)
          throw m;
        D(1, 0);
      }
    }
    function Qo(e, t, r, o, s) {
      var u = x();
      try {
        I(e)(t, r, o, s);
      } catch (l) {
        if (R(u), l !== l + 0)
          throw l;
        D(1, 0);
      }
    }
    function Xo(e, t, r, o, s, u, l) {
      var f = x();
      try {
        return I(e)(t, r, o, s, u, l);
      } catch (p) {
        if (R(f), p !== p + 0)
          throw p;
        D(1, 0);
      }
    }
    function Zo(e, t, r, o, s, u, l, f, p) {
      var m = x();
      try {
        I(e)(t, r, o, s, u, l, f, p);
      } catch (b) {
        if (R(m), b !== b + 0)
          throw b;
        D(1, 0);
      }
    }
    function Ko(e) {
      var t = x();
      try {
        return I(e)();
      } catch (r) {
        if (R(t), r !== r + 0)
          throw r;
        D(1, 0);
      }
    }
    function ea(e, t, r, o, s, u, l) {
      var f = x();
      try {
        return I(e)(t, r, o, s, u, l);
      } catch (p) {
        if (R(f), p !== p + 0)
          throw p;
        D(1, 0);
      }
    }
    function ta(e, t, r, o) {
      var s = x();
      try {
        return I(e)(t, r, o);
      } catch (u) {
        if (R(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function ra(e, t, r, o) {
      var s = x();
      try {
        return I(e)(t, r, o);
      } catch (u) {
        if (R(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function na(e, t, r, o, s, u) {
      var l = x();
      try {
        return I(e)(t, r, o, s, u);
      } catch (f) {
        if (R(l), f !== f + 0)
          throw f;
        D(1, 0);
      }
    }
    function oa(e, t, r, o, s, u) {
      var l = x();
      try {
        return I(e)(t, r, o, s, u);
      } catch (f) {
        if (R(l), f !== f + 0)
          throw f;
        D(1, 0);
      }
    }
    function aa(e, t, r, o, s, u, l, f, p, m) {
      var b = x();
      try {
        return I(e)(t, r, o, s, u, l, f, p, m);
      } catch (T) {
        if (R(b), T !== T + 0)
          throw T;
        D(1, 0);
      }
    }
    function ia(e, t, r) {
      var o = x();
      try {
        return I(e)(t, r);
      } catch (s) {
        if (R(o), s !== s + 0)
          throw s;
        D(1, 0);
      }
    }
    function sa(e, t, r, o, s, u, l, f, p, m) {
      var b = x();
      try {
        I(e)(t, r, o, s, u, l, f, p, m);
      } catch (T) {
        if (R(b), T !== T + 0)
          throw T;
        D(1, 0);
      }
    }
    function ua(e, t, r, o, s, u, l, f) {
      var p = x();
      try {
        return I(e)(t, r, o, s, u, l, f);
      } catch (m) {
        if (R(p), m !== m + 0)
          throw m;
        D(1, 0);
      }
    }
    function ca(e, t, r, o, s, u, l, f, p) {
      var m = x();
      try {
        return I(e)(t, r, o, s, u, l, f, p);
      } catch (b) {
        if (R(m), b !== b + 0)
          throw b;
        D(1, 0);
      }
    }
    function la(e, t, r, o, s, u, l) {
      var f = x();
      try {
        I(e)(t, r, o, s, u, l);
      } catch (p) {
        if (R(f), p !== p + 0)
          throw p;
        D(1, 0);
      }
    }
    function fa(e, t, r, o) {
      var s = x();
      try {
        return I(e)(t, r, o);
      } catch (u) {
        if (R(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function da(e, t, r, o, s, u, l, f, p, m, b, T) {
      var E = x();
      try {
        return I(e)(t, r, o, s, u, l, f, p, m, b, T);
      } catch (k) {
        if (R(E), k !== k + 0)
          throw k;
        D(1, 0);
      }
    }
    function pa(e, t, r, o, s, u, l, f, p, m, b, T, E, k, H, q) {
      var V = x();
      try {
        I(e)(t, r, o, s, u, l, f, p, m, b, T, E, k, H, q);
      } catch (Y) {
        if (R(V), Y !== Y + 0)
          throw Y;
        D(1, 0);
      }
    }
    function ha(e, t, r, o) {
      var s = x();
      try {
        return dr(e, t, r, o);
      } catch (u) {
        if (R(s), u !== u + 0)
          throw u;
        D(1, 0);
      }
    }
    function va(e, t, r, o, s) {
      var u = x();
      try {
        return pr(e, t, r, o, s);
      } catch (l) {
        if (R(u), l !== l + 0)
          throw l;
        D(1, 0);
      }
    }
    var Ke;
    ve = function e() {
      Ke || hr(), Ke || (ve = e);
    };
    function hr() {
      if (J > 0 || (ut(), J > 0))
        return;
      function e() {
        Ke || (Ke = !0, a.calledRun = !0, !z && (Me(), c(a), a.onRuntimeInitialized && a.onRuntimeInitialized(), He()));
      }
      a.setStatus ? (a.setStatus("Running..."), setTimeout(function() {
        setTimeout(function() {
          a.setStatus("");
        }, 1), e();
      }, 1)) : e();
    }
    if (a.preInit)
      for (typeof a.preInit == "function" && (a.preInit = [a.preInit]); a.preInit.length > 0; )
        a.preInit.pop()();
    return hr(), i.ready;
  };
})();
function za(n) {
  return Dr(xr, n);
}
async function Ba(n, {
  tryHarder: i = de.tryHarder,
  formats: a = de.formats,
  maxSymbols: c = de.maxSymbols
} = de) {
  return La(
    n,
    {
      tryHarder: i,
      formats: a,
      maxSymbols: c
    },
    xr
  );
}
const Rr = /* @__PURE__ */ new Map([
  ["aztec", "Aztec"],
  ["code_128", "Code128"],
  ["code_39", "Code39"],
  ["code_93", "Code93"],
  ["codabar", "Codabar"],
  ["data_matrix", "DataMatrix"],
  ["ean_13", "EAN-13"],
  ["ean_8", "EAN-8"],
  ["itf", "ITF"],
  ["pdf417", "PDF417"],
  ["qr_code", "QRCode"],
  ["upc_a", "UPC-A"],
  ["upc_e", "UPC-E"]
]);
function Ga(n) {
  for (const [i, a] of Rr)
    if (n === a)
      return i;
  return "unknown";
}
var nt;
class st {
  constructor(i = {}) {
    $a(this, nt, void 0);
    var a;
    try {
      const c = (a = i == null ? void 0 : i.formats) == null ? void 0 : a.filter(
        (d) => d !== "unknown"
      );
      if ((c == null ? void 0 : c.length) === 0)
        throw new TypeError("Hint option provided, but is empty.");
      c == null || c.forEach((d) => {
        if (!vr.includes(d))
          throw new TypeError(
            `Failed to read the 'formats' property from 'BarcodeDetectorOptions': The provided value '${d}' is not a valid enum value of type BarcodeFormat.`
          );
      }), za().catch(() => {
      }), Sa(this, nt, c ?? []);
    } catch (c) {
      throw mr(
        c,
        "Failed to construct 'BarcodeDetector'"
      );
    }
  }
  static async getSupportedFormats() {
    return vr.filter((i) => i !== "unknown");
  }
  async detect(i) {
    try {
      const a = await xa(i);
      if (a === null)
        return [];
      let c;
      try {
        c = await Ba(a, {
          tryHarder: !0,
          formats: _a(this, nt).map(
            (d) => Rr.get(d)
          )
        });
      } catch (d) {
        throw new DOMException(
          "Barcode detection service unavailable. Use 'setZXingModuleOverrides' in offline or strict CSP environments.",
          "NotSupportedError"
        );
      }
      return c.map((d) => {
        const {
          topLeft: { x: h, y: v },
          topRight: { x: w, y: C },
          bottomLeft: { x: y, y: _ },
          bottomRight: { x: S, y: $ }
        } = d.position, j = Math.min(h, w, y, S), U = Math.min(v, C, _, $), O = Math.max(h, w, y, S), z = Math.max(v, C, _, $);
        return {
          boundingBox: new DOMRectReadOnly(
            j,
            U,
            O - j,
            z - U
          ),
          rawValue: new TextDecoder().decode(d.bytes),
          format: Ga(d.format),
          cornerPoints: [
            {
              x: h,
              y: v
            },
            {
              x: w,
              y: C
            },
            {
              x: S,
              y: $
            },
            {
              x: y,
              y: _
            }
          ]
        };
      });
    } catch (a) {
      throw mr(
        a,
        "Failed to execute 'detect' on 'BarcodeDetector'"
      );
    }
  }
}
nt = /* @__PURE__ */ new WeakMap();
const kr = (n, i, a = "error") => {
  let c, d;
  const h = new Promise(
    (v, w) => {
      c = v, d = w, n.addEventListener(i, c), n.addEventListener(a, d);
    }
  );
  return h.finally(() => {
    n.removeEventListener(i, c), n.removeEventListener(a, d);
  }), h;
}, br = (n) => new Promise((i) => setTimeout(i, n));
class Na extends Error {
  constructor() {
    super("can't process cross-origin image"), this.name = "DropImageFetchError";
  }
}
class Fr extends Error {
  constructor() {
    super("this browser has no Stream API support"), this.name = "StreamApiNotSupportedError";
  }
}
class qa extends Error {
  constructor() {
    super(
      "camera access is only permitted in secure context. Use HTTPS or localhost rather than HTTP."
    ), this.name = "InsecureContextError";
  }
}
class Ya extends Error {
  constructor() {
    super("Loading camera stream timed out after 3 seconds. If you are on iOS in PWA mode, this is a known issue (see https://github.com/gruhn/vue-qrcode-reader/issues/298)"), this.name = "StreamLoadTimeoutError";
  }
}
let At;
const Ja = (n) => {
  At = new st({ formats: n });
}, Qa = async (n, {
  detectHandler: i,
  locateHandler: a,
  minDelay: c,
  formats: d
}) => {
  At = new st({ formats: d });
  const h = (v) => async (w) => {
    if (n.readyState > 1) {
      const { lastScanned: C, contentBefore: y, lastScanHadContent: _ } = v;
      if (w - C < c)
        window.requestAnimationFrame(h(v));
      else {
        const S = await At.detect(n), $ = S.some((O) => !y.includes(O.rawValue));
        $ && i(S);
        const j = S.length > 0;
        j && a(S), !j && _ && a(S);
        const U = {
          lastScanned: w,
          lastScanHadContent: j,
          // It can happen that a QR code is constantly in view of the camera but
          // maybe a scanned frame is a bit blurry and we detect nothing but in the
          // next frame we detect the code again. We also want to avoid emitting
          // a `detect` event in such a case. So we don't reset `contentBefore`,
          // if we detect nothing, only if we detect something new.
          contentBefore: $ ? S.map((O) => O.rawValue) : y
        };
        window.requestAnimationFrame(h(U));
      }
    }
  };
  h({
    lastScanned: performance.now(),
    contentBefore: [],
    lastScanHadContent: !1
  })(performance.now());
}, Xa = async (n) => {
  if (n.startsWith("http") && n.includes(location.host) === !1)
    throw new Na();
  const i = document.createElement("img");
  return i.src = n, await kr(i, "load"), i;
}, Ir = async (n, i = ["qr_code"]) => await new st({
  formats: i
}).detect(n), Za = async (n, i = ["qr_code"]) => {
  const a = new st({
    formats: i
  }), c = await Xa(n);
  return await a.detect(c);
};
var Ur = {}, X = {};
Object.defineProperty(X, "__esModule", {
  value: !0
});
X.compactObject = Lr;
X.deprecated = si;
var Ka = X.detectBrowser = ui;
X.disableLog = oi;
X.disableWarnings = ai;
X.extractVersion = ot;
X.filterStats = ci;
X.log = ii;
X.walkStats = at;
X.wrapPeerConnectionEvent = ni;
function ei(n, i, a) {
  return i = ti(i), i in n ? Object.defineProperty(n, i, { value: a, enumerable: !0, configurable: !0, writable: !0 }) : n[i] = a, n;
}
function ti(n) {
  var i = ri(n, "string");
  return pe(i) === "symbol" ? i : String(i);
}
function ri(n, i) {
  if (pe(n) !== "object" || n === null)
    return n;
  var a = n[Symbol.toPrimitive];
  if (a !== void 0) {
    var c = a.call(n, i || "default");
    if (pe(c) !== "object")
      return c;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (i === "string" ? String : Number)(n);
}
function pe(n) {
  "@babel/helpers - typeof";
  return pe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, pe(n);
}
var jr = !0, Wr = !0;
function ot(n, i, a) {
  var c = n.match(i);
  return c && c.length >= a && parseInt(c[a], 10);
}
function ni(n, i, a) {
  if (n.RTCPeerConnection) {
    var c = n.RTCPeerConnection.prototype, d = c.addEventListener;
    c.addEventListener = function(v, w) {
      if (v !== i)
        return d.apply(this, arguments);
      var C = function(_) {
        var S = a(_);
        S && (w.handleEvent ? w.handleEvent(S) : w(S));
      };
      return this._eventMap = this._eventMap || {}, this._eventMap[i] || (this._eventMap[i] = /* @__PURE__ */ new Map()), this._eventMap[i].set(w, C), d.apply(this, [v, C]);
    };
    var h = c.removeEventListener;
    c.removeEventListener = function(v, w) {
      if (v !== i || !this._eventMap || !this._eventMap[i])
        return h.apply(this, arguments);
      if (!this._eventMap[i].has(w))
        return h.apply(this, arguments);
      var C = this._eventMap[i].get(w);
      return this._eventMap[i].delete(w), this._eventMap[i].size === 0 && delete this._eventMap[i], Object.keys(this._eventMap).length === 0 && delete this._eventMap, h.apply(this, [v, C]);
    }, Object.defineProperty(c, "on" + i, {
      get: function() {
        return this["_on" + i];
      },
      set: function(w) {
        this["_on" + i] && (this.removeEventListener(i, this["_on" + i]), delete this["_on" + i]), w && this.addEventListener(i, this["_on" + i] = w);
      },
      enumerable: !0,
      configurable: !0
    });
  }
}
function oi(n) {
  return typeof n != "boolean" ? new Error("Argument type: " + pe(n) + ". Please use a boolean.") : (jr = n, n ? "adapter.js logging disabled" : "adapter.js logging enabled");
}
function ai(n) {
  return typeof n != "boolean" ? new Error("Argument type: " + pe(n) + ". Please use a boolean.") : (Wr = !n, "adapter.js deprecation warnings " + (n ? "disabled" : "enabled"));
}
function ii() {
  if ((typeof window > "u" ? "undefined" : pe(window)) === "object") {
    if (jr)
      return;
    typeof console < "u" && typeof console.log == "function" && console.log.apply(console, arguments);
  }
}
function si(n, i) {
  Wr && console.warn(n + " is deprecated, please use " + i + " instead.");
}
function ui(n) {
  var i = {
    browser: null,
    version: null
  };
  if (typeof n > "u" || !n.navigator || !n.navigator.userAgent)
    return i.browser = "Not a browser.", i;
  var a = n.navigator;
  if (a.mozGetUserMedia)
    i.browser = "firefox", i.version = ot(a.userAgent, /Firefox\/(\d+)\./, 1);
  else if (a.webkitGetUserMedia || n.isSecureContext === !1 && n.webkitRTCPeerConnection)
    i.browser = "chrome", i.version = ot(a.userAgent, /Chrom(e|ium)\/(\d+)\./, 2);
  else if (n.RTCPeerConnection && a.userAgent.match(/AppleWebKit\/(\d+)\./))
    i.browser = "safari", i.version = ot(a.userAgent, /AppleWebKit\/(\d+)\./, 1), i.supportsUnifiedPlan = n.RTCRtpTransceiver && "currentDirection" in n.RTCRtpTransceiver.prototype;
  else
    return i.browser = "Not a supported browser.", i;
  return i;
}
function Cr(n) {
  return Object.prototype.toString.call(n) === "[object Object]";
}
function Lr(n) {
  return Cr(n) ? Object.keys(n).reduce(function(i, a) {
    var c = Cr(n[a]), d = c ? Lr(n[a]) : n[a], h = c && !Object.keys(d).length;
    return d === void 0 || h ? i : Object.assign(i, ei({}, a, d));
  }, {}) : n;
}
function at(n, i, a) {
  !i || a.has(i.id) || (a.set(i.id, i), Object.keys(i).forEach(function(c) {
    c.endsWith("Id") ? at(n, n.get(i[c]), a) : c.endsWith("Ids") && i[c].forEach(function(d) {
      at(n, n.get(d), a);
    });
  }));
}
function ci(n, i, a) {
  var c = a ? "outbound-rtp" : "inbound-rtp", d = /* @__PURE__ */ new Map();
  if (i === null)
    return d;
  var h = [];
  return n.forEach(function(v) {
    v.type === "track" && v.trackIdentifier === i.id && h.push(v);
  }), h.forEach(function(v) {
    n.forEach(function(w) {
      w.type === c && w.trackId === v.id && at(n, w, d);
    });
  }), d;
}
Object.defineProperty(Ur, "__esModule", {
  value: !0
});
var li = Ur.shimGetUserMedia = pi, fi = di(X);
function Hr(n) {
  if (typeof WeakMap != "function")
    return null;
  var i = /* @__PURE__ */ new WeakMap(), a = /* @__PURE__ */ new WeakMap();
  return (Hr = function(d) {
    return d ? a : i;
  })(n);
}
function di(n, i) {
  if (!i && n && n.__esModule)
    return n;
  if (n === null || fe(n) !== "object" && typeof n != "function")
    return { default: n };
  var a = Hr(i);
  if (a && a.has(n))
    return a.get(n);
  var c = {}, d = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var h in n)
    if (h !== "default" && Object.prototype.hasOwnProperty.call(n, h)) {
      var v = d ? Object.getOwnPropertyDescriptor(n, h) : null;
      v && (v.get || v.set) ? Object.defineProperty(c, h, v) : c[h] = n[h];
    }
  return c.default = n, a && a.set(n, c), c;
}
function fe(n) {
  "@babel/helpers - typeof";
  return fe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, fe(n);
}
var _r = fi.log;
function pi(n, i) {
  var a = n && n.navigator;
  if (a.mediaDevices) {
    var c = function(y) {
      if (fe(y) !== "object" || y.mandatory || y.optional)
        return y;
      var _ = {};
      return Object.keys(y).forEach(function(S) {
        if (!(S === "require" || S === "advanced" || S === "mediaSource")) {
          var $ = fe(y[S]) === "object" ? y[S] : {
            ideal: y[S]
          };
          $.exact !== void 0 && typeof $.exact == "number" && ($.min = $.max = $.exact);
          var j = function(z, M) {
            return z ? z + M.charAt(0).toUpperCase() + M.slice(1) : M === "deviceId" ? "sourceId" : M;
          };
          if ($.ideal !== void 0) {
            _.optional = _.optional || [];
            var U = {};
            typeof $.ideal == "number" ? (U[j("min", S)] = $.ideal, _.optional.push(U), U = {}, U[j("max", S)] = $.ideal, _.optional.push(U)) : (U[j("", S)] = $.ideal, _.optional.push(U));
          }
          $.exact !== void 0 && typeof $.exact != "number" ? (_.mandatory = _.mandatory || {}, _.mandatory[j("", S)] = $.exact) : ["min", "max"].forEach(function(O) {
            $[O] !== void 0 && (_.mandatory = _.mandatory || {}, _.mandatory[j(O, S)] = $[O]);
          });
        }
      }), y.advanced && (_.optional = (_.optional || []).concat(y.advanced)), _;
    }, d = function(y, _) {
      if (i.version >= 61)
        return _(y);
      if (y = JSON.parse(JSON.stringify(y)), y && fe(y.audio) === "object") {
        var S = function(z, M, A) {
          M in z && !(A in z) && (z[A] = z[M], delete z[M]);
        };
        y = JSON.parse(JSON.stringify(y)), S(y.audio, "autoGainControl", "googAutoGainControl"), S(y.audio, "noiseSuppression", "googNoiseSuppression"), y.audio = c(y.audio);
      }
      if (y && fe(y.video) === "object") {
        var $ = y.video.facingMode;
        $ = $ && (fe($) === "object" ? $ : {
          ideal: $
        });
        var j = i.version < 66;
        if ($ && ($.exact === "user" || $.exact === "environment" || $.ideal === "user" || $.ideal === "environment") && !(a.mediaDevices.getSupportedConstraints && a.mediaDevices.getSupportedConstraints().facingMode && !j)) {
          delete y.video.facingMode;
          var U;
          if ($.exact === "environment" || $.ideal === "environment" ? U = ["back", "rear"] : ($.exact === "user" || $.ideal === "user") && (U = ["front"]), U)
            return a.mediaDevices.enumerateDevices().then(function(O) {
              O = O.filter(function(M) {
                return M.kind === "videoinput";
              });
              var z = O.find(function(M) {
                return U.some(function(A) {
                  return M.label.toLowerCase().includes(A);
                });
              });
              return !z && O.length && U.includes("back") && (z = O[O.length - 1]), z && (y.video.deviceId = $.exact ? {
                exact: z.deviceId
              } : {
                ideal: z.deviceId
              }), y.video = c(y.video), _r("chrome: " + JSON.stringify(y)), _(y);
            });
        }
        y.video = c(y.video);
      }
      return _r("chrome: " + JSON.stringify(y)), _(y);
    }, h = function(y) {
      return i.version >= 64 ? y : {
        name: {
          PermissionDeniedError: "NotAllowedError",
          PermissionDismissedError: "NotAllowedError",
          InvalidStateError: "NotAllowedError",
          DevicesNotFoundError: "NotFoundError",
          ConstraintNotSatisfiedError: "OverconstrainedError",
          TrackStartError: "NotReadableError",
          MediaDeviceFailedDueToShutdown: "NotAllowedError",
          MediaDeviceKillSwitchOn: "NotAllowedError",
          TabCaptureError: "AbortError",
          ScreenCaptureError: "AbortError",
          DeviceCaptureError: "AbortError"
        }[y.name] || y.name,
        message: y.message,
        constraint: y.constraint || y.constraintName,
        toString: function() {
          return this.name + (this.message && ": ") + this.message;
        }
      };
    }, v = function(y, _, S) {
      d(y, function($) {
        a.webkitGetUserMedia($, _, function(j) {
          S && S(h(j));
        });
      });
    };
    if (a.getUserMedia = v.bind(a), a.mediaDevices.getUserMedia) {
      var w = a.mediaDevices.getUserMedia.bind(a.mediaDevices);
      a.mediaDevices.getUserMedia = function(C) {
        return d(C, function(y) {
          return w(y).then(function(_) {
            if (y.audio && !_.getAudioTracks().length || y.video && !_.getVideoTracks().length)
              throw _.getTracks().forEach(function(S) {
                S.stop();
              }), new DOMException("", "NotFoundError");
            return _;
          }, function(_) {
            return Promise.reject(h(_));
          });
        });
      };
    }
  }
}
var Vr = {};
Object.defineProperty(Vr, "__esModule", {
  value: !0
});
var hi = Vr.shimGetUserMedia = yi, vi = mi(X);
function zr(n) {
  if (typeof WeakMap != "function")
    return null;
  var i = /* @__PURE__ */ new WeakMap(), a = /* @__PURE__ */ new WeakMap();
  return (zr = function(d) {
    return d ? a : i;
  })(n);
}
function mi(n, i) {
  if (!i && n && n.__esModule)
    return n;
  if (n === null || Pe(n) !== "object" && typeof n != "function")
    return { default: n };
  var a = zr(i);
  if (a && a.has(n))
    return a.get(n);
  var c = {}, d = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var h in n)
    if (h !== "default" && Object.prototype.hasOwnProperty.call(n, h)) {
      var v = d ? Object.getOwnPropertyDescriptor(n, h) : null;
      v && (v.get || v.set) ? Object.defineProperty(c, h, v) : c[h] = n[h];
    }
  return c.default = n, a && a.set(n, c), c;
}
function Pe(n) {
  "@babel/helpers - typeof";
  return Pe = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, Pe(n);
}
function yi(n, i) {
  var a = n && n.navigator, c = n && n.MediaStreamTrack;
  if (a.getUserMedia = function(C, y, _) {
    vi.deprecated("navigator.getUserMedia", "navigator.mediaDevices.getUserMedia"), a.mediaDevices.getUserMedia(C).then(y, _);
  }, !(i.version > 55 && "autoGainControl" in a.mediaDevices.getSupportedConstraints())) {
    var d = function(y, _, S) {
      _ in y && !(S in y) && (y[S] = y[_], delete y[_]);
    }, h = a.mediaDevices.getUserMedia.bind(a.mediaDevices);
    if (a.mediaDevices.getUserMedia = function(C) {
      return Pe(C) === "object" && Pe(C.audio) === "object" && (C = JSON.parse(JSON.stringify(C)), d(C.audio, "autoGainControl", "mozAutoGainControl"), d(C.audio, "noiseSuppression", "mozNoiseSuppression")), h(C);
    }, c && c.prototype.getSettings) {
      var v = c.prototype.getSettings;
      c.prototype.getSettings = function() {
        var C = v.apply(this, arguments);
        return d(C, "mozAutoGainControl", "autoGainControl"), d(C, "mozNoiseSuppression", "noiseSuppression"), C;
      };
    }
    if (c && c.prototype.applyConstraints) {
      var w = c.prototype.applyConstraints;
      c.prototype.applyConstraints = function(C) {
        return this.kind === "audio" && Pe(C) === "object" && (C = JSON.parse(JSON.stringify(C)), d(C, "autoGainControl", "mozAutoGainControl"), d(C, "noiseSuppression", "mozNoiseSuppression")), w.apply(this, [C]);
      };
    }
  }
}
var te = {};
Object.defineProperty(te, "__esModule", {
  value: !0
});
te.shimAudioContext = Ei;
te.shimCallbacksAPI = _i;
te.shimConstraints = Nr;
te.shimCreateOfferLegacy = Ti;
var gi = te.shimGetUserMedia = $i;
te.shimLocalStreamsAPI = bi;
te.shimRTCIceServerUrls = Si;
te.shimRemoteStreamsAPI = Ci;
te.shimTrackEventTransceiver = Pi;
var Br = wi(X);
function Gr(n) {
  if (typeof WeakMap != "function")
    return null;
  var i = /* @__PURE__ */ new WeakMap(), a = /* @__PURE__ */ new WeakMap();
  return (Gr = function(d) {
    return d ? a : i;
  })(n);
}
function wi(n, i) {
  if (!i && n && n.__esModule)
    return n;
  if (n === null || he(n) !== "object" && typeof n != "function")
    return { default: n };
  var a = Gr(i);
  if (a && a.has(n))
    return a.get(n);
  var c = {}, d = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var h in n)
    if (h !== "default" && Object.prototype.hasOwnProperty.call(n, h)) {
      var v = d ? Object.getOwnPropertyDescriptor(n, h) : null;
      v && (v.get || v.set) ? Object.defineProperty(c, h, v) : c[h] = n[h];
    }
  return c.default = n, a && a.set(n, c), c;
}
function he(n) {
  "@babel/helpers - typeof";
  return he = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(i) {
    return typeof i;
  } : function(i) {
    return i && typeof Symbol == "function" && i.constructor === Symbol && i !== Symbol.prototype ? "symbol" : typeof i;
  }, he(n);
}
function bi(n) {
  if (!(he(n) !== "object" || !n.RTCPeerConnection)) {
    if ("getLocalStreams" in n.RTCPeerConnection.prototype || (n.RTCPeerConnection.prototype.getLocalStreams = function() {
      return this._localStreams || (this._localStreams = []), this._localStreams;
    }), !("addStream" in n.RTCPeerConnection.prototype)) {
      var i = n.RTCPeerConnection.prototype.addTrack;
      n.RTCPeerConnection.prototype.addStream = function(c) {
        var d = this;
        this._localStreams || (this._localStreams = []), this._localStreams.includes(c) || this._localStreams.push(c), c.getAudioTracks().forEach(function(h) {
          return i.call(d, h, c);
        }), c.getVideoTracks().forEach(function(h) {
          return i.call(d, h, c);
        });
      }, n.RTCPeerConnection.prototype.addTrack = function(c) {
        for (var d = this, h = arguments.length, v = new Array(h > 1 ? h - 1 : 0), w = 1; w < h; w++)
          v[w - 1] = arguments[w];
        return v && v.forEach(function(C) {
          d._localStreams ? d._localStreams.includes(C) || d._localStreams.push(C) : d._localStreams = [C];
        }), i.apply(this, arguments);
      };
    }
    "removeStream" in n.RTCPeerConnection.prototype || (n.RTCPeerConnection.prototype.removeStream = function(c) {
      var d = this;
      this._localStreams || (this._localStreams = []);
      var h = this._localStreams.indexOf(c);
      if (h !== -1) {
        this._localStreams.splice(h, 1);
        var v = c.getTracks();
        this.getSenders().forEach(function(w) {
          v.includes(w.track) && d.removeTrack(w);
        });
      }
    });
  }
}
function Ci(n) {
  if (!(he(n) !== "object" || !n.RTCPeerConnection) && ("getRemoteStreams" in n.RTCPeerConnection.prototype || (n.RTCPeerConnection.prototype.getRemoteStreams = function() {
    return this._remoteStreams ? this._remoteStreams : [];
  }), !("onaddstream" in n.RTCPeerConnection.prototype))) {
    Object.defineProperty(n.RTCPeerConnection.prototype, "onaddstream", {
      get: function() {
        return this._onaddstream;
      },
      set: function(c) {
        var d = this;
        this._onaddstream && (this.removeEventListener("addstream", this._onaddstream), this.removeEventListener("track", this._onaddstreampoly)), this.addEventListener("addstream", this._onaddstream = c), this.addEventListener("track", this._onaddstreampoly = function(h) {
          h.streams.forEach(function(v) {
            if (d._remoteStreams || (d._remoteStreams = []), !d._remoteStreams.includes(v)) {
              d._remoteStreams.push(v);
              var w = new Event("addstream");
              w.stream = v, d.dispatchEvent(w);
            }
          });
        });
      }
    });
    var i = n.RTCPeerConnection.prototype.setRemoteDescription;
    n.RTCPeerConnection.prototype.setRemoteDescription = function() {
      var c = this;
      return this._onaddstreampoly || this.addEventListener("track", this._onaddstreampoly = function(d) {
        d.streams.forEach(function(h) {
          if (c._remoteStreams || (c._remoteStreams = []), !(c._remoteStreams.indexOf(h) >= 0)) {
            c._remoteStreams.push(h);
            var v = new Event("addstream");
            v.stream = h, c.dispatchEvent(v);
          }
        });
      }), i.apply(c, arguments);
    };
  }
}
function _i(n) {
  if (!(he(n) !== "object" || !n.RTCPeerConnection)) {
    var i = n.RTCPeerConnection.prototype, a = i.createOffer, c = i.createAnswer, d = i.setLocalDescription, h = i.setRemoteDescription, v = i.addIceCandidate;
    i.createOffer = function(y, _) {
      var S = arguments.length >= 2 ? arguments[2] : arguments[0], $ = a.apply(this, [S]);
      return _ ? ($.then(y, _), Promise.resolve()) : $;
    }, i.createAnswer = function(y, _) {
      var S = arguments.length >= 2 ? arguments[2] : arguments[0], $ = c.apply(this, [S]);
      return _ ? ($.then(y, _), Promise.resolve()) : $;
    };
    var w = function(y, _, S) {
      var $ = d.apply(this, [y]);
      return S ? ($.then(_, S), Promise.resolve()) : $;
    };
    i.setLocalDescription = w, w = function(y, _, S) {
      var $ = h.apply(this, [y]);
      return S ? ($.then(_, S), Promise.resolve()) : $;
    }, i.setRemoteDescription = w, w = function(y, _, S) {
      var $ = v.apply(this, [y]);
      return S ? ($.then(_, S), Promise.resolve()) : $;
    }, i.addIceCandidate = w;
  }
}
function $i(n) {
  var i = n && n.navigator;
  if (i.mediaDevices && i.mediaDevices.getUserMedia) {
    var a = i.mediaDevices, c = a.getUserMedia.bind(a);
    i.mediaDevices.getUserMedia = function(d) {
      return c(Nr(d));
    };
  }
  !i.getUserMedia && i.mediaDevices && i.mediaDevices.getUserMedia && (i.getUserMedia = (function(h, v, w) {
    i.mediaDevices.getUserMedia(h).then(v, w);
  }).bind(i));
}
function Nr(n) {
  return n && n.video !== void 0 ? Object.assign({}, n, {
    video: Br.compactObject(n.video)
  }) : n;
}
function Si(n) {
  if (n.RTCPeerConnection) {
    var i = n.RTCPeerConnection;
    n.RTCPeerConnection = function(c, d) {
      if (c && c.iceServers) {
        for (var h = [], v = 0; v < c.iceServers.length; v++) {
          var w = c.iceServers[v];
          w.urls === void 0 && w.url ? (Br.deprecated("RTCIceServer.url", "RTCIceServer.urls"), w = JSON.parse(JSON.stringify(w)), w.urls = w.url, delete w.url, h.push(w)) : h.push(c.iceServers[v]);
        }
        c.iceServers = h;
      }
      return new i(c, d);
    }, n.RTCPeerConnection.prototype = i.prototype, "generateCertificate" in i && Object.defineProperty(n.RTCPeerConnection, "generateCertificate", {
      get: function() {
        return i.generateCertificate;
      }
    });
  }
}
function Pi(n) {
  he(n) === "object" && n.RTCTrackEvent && "receiver" in n.RTCTrackEvent.prototype && !("transceiver" in n.RTCTrackEvent.prototype) && Object.defineProperty(n.RTCTrackEvent.prototype, "transceiver", {
    get: function() {
      return {
        receiver: this.receiver
      };
    }
  });
}
function Ti(n) {
  var i = n.RTCPeerConnection.prototype.createOffer;
  n.RTCPeerConnection.prototype.createOffer = function(c) {
    if (c) {
      typeof c.offerToReceiveAudio < "u" && (c.offerToReceiveAudio = !!c.offerToReceiveAudio);
      var d = this.getTransceivers().find(function(v) {
        return v.receiver.track.kind === "audio";
      });
      c.offerToReceiveAudio === !1 && d ? d.direction === "sendrecv" ? d.setDirection ? d.setDirection("sendonly") : d.direction = "sendonly" : d.direction === "recvonly" && (d.setDirection ? d.setDirection("inactive") : d.direction = "inactive") : c.offerToReceiveAudio === !0 && !d && this.addTransceiver("audio", {
        direction: "recvonly"
      }), typeof c.offerToReceiveVideo < "u" && (c.offerToReceiveVideo = !!c.offerToReceiveVideo);
      var h = this.getTransceivers().find(function(v) {
        return v.receiver.track.kind === "video";
      });
      c.offerToReceiveVideo === !1 && h ? h.direction === "sendrecv" ? h.setDirection ? h.setDirection("sendonly") : h.direction = "sendonly" : h.direction === "recvonly" && (h.setDirection ? h.setDirection("inactive") : h.direction = "inactive") : c.offerToReceiveVideo === !0 && !h && this.addTransceiver("video", {
        direction: "recvonly"
      });
    }
    return i.apply(this, arguments);
  };
}
function Ei(n) {
  he(n) !== "object" || n.AudioContext || (n.AudioContext = n.webkitAudioContext);
}
const Oi = (n) => {
  let i = !1, a;
  return (...c) => (i || (a = n(c), i = !0), a);
};
function ie(n, i) {
  if (n === !1)
    throw new Error(i ?? "assertion failure");
}
const Mi = Oi(() => {
  const n = Ka(window);
  switch (n.browser) {
    case "chrome":
      li(window, n);
      break;
    case "firefox":
      hi(window, n);
      break;
    case "safari":
      gi(window, n);
      break;
    default:
      throw new Fr();
  }
});
let se = { isActive: !1 };
function Mt() {
  if (se.isActive) {
    se.videoEl.src = "", se.videoEl.srcObject = null, se.videoEl.load();
    for (const n of se.stream.getTracks())
      se.stream.removeTrack(n), n.stop();
    se = { isActive: !1 };
  }
}
async function Ai(n, { constraints: i, torch: a }) {
  var h, v;
  if (window.isSecureContext !== !0)
    throw new qa();
  if (((h = navigator == null ? void 0 : navigator.mediaDevices) == null ? void 0 : h.getUserMedia) === void 0)
    throw new Fr();
  Mi();
  const c = await navigator.mediaDevices.getUserMedia({
    audio: !1,
    video: i
  });
  if (n.srcObject !== void 0 ? n.srcObject = c : n.mozSrcObject !== void 0 ? n.mozSrcObject = c : window.URL.createObjectURL ? n.src = window.URL.createObjectURL(c) : window.webkitURL ? n.src = window.webkitURL.createObjectURL(c) : n.src = c.id, await Promise.race([
    kr(n, "loadeddata"),
    // On iOS devices in PWA mode, QrcodeStream works initially, but after
    // killing and restarting the PWA, all video elements fail to load camera 
    // streams and never emit the `loadeddata` event. Looks like this is 
    // related to a WebKit issue (see #298). No workarounds at the moment. 
    // To at least detect this situation, we throw an error if the event
    // has not been emitted after a 3 second timeout.
    br(3e3).then(() => {
      throw new Ya();
    })
  ]), await br(500), a) {
    const [w] = c.getVideoTracks();
    w.getCapabilities().torch ? w.applyConstraints({ advanced: [{ torch: !0 }] }) : console.warn("device does not support torch capability");
  }
  se = { videoEl: n, stream: c, isActive: !0 };
  const [d] = se.stream.getVideoTracks();
  return ((v = d == null ? void 0 : d.getCapabilities) == null ? void 0 : v.call(d)) ?? {};
}
const Di = /* @__PURE__ */ Dt({
  __name: "QrcodeStream",
  props: {
    constraints: {
      type: Object,
      default() {
        return { facingMode: "environment" };
      }
    },
    formats: {
      type: Array,
      default: () => ["qr_code"]
    },
    paused: {
      type: Boolean,
      default: !1
    },
    torch: {
      type: Boolean,
      default: !1
    },
    track: {
      type: Function
    }
  },
  emits: ["detect", "camera-on", "camera-off", "error"],
  setup(n, { emit: i }) {
    const a = n, c = Ue(), d = Ue(), h = Ue(), v = Ue(!1), w = Ue(!1);
    ma(() => {
      w.value = !0;
    }), ya(() => {
      Mt();
    });
    const C = Et(() => ({
      torch: a.torch,
      constraints: a.constraints,
      shouldStream: w.value && !a.paused
    }));
    Ot(C, async (M) => {
      const A = h.value;
      ie(A !== void 0, "cameraSettings watcher should never be triggered when component is not mounted. Thus video element should always be defined.");
      const B = c.value;
      ie(B !== void 0, "cameraSettings watcher should never be triggered when component is not mounted. Thus canvas should always be defined.");
      const ee = B.getContext("2d");
      if (ie(ee !== null, "if cavnas is defined, canvas 2d context should also be non-null"), M.shouldStream)
        try {
          const W = await Ai(A, M);
          w.value ? (v.value = !0, i("camera-on", W)) : Mt();
        } catch (W) {
          i("error", W);
        }
      else
        B.width = A.videoWidth, B.height = A.videoHeight, ee.drawImage(A, 0, 0, A.videoWidth, A.videoHeight), Mt(), v.value = !1, i("camera-off");
    }, { deep: !0 });
    const { formats: y } = ga(a);
    Ot(y, (M) => {
      w.value && Ja(M);
    });
    const _ = Et(() => C.value.shouldStream && v.value);
    Ot(_, (M) => {
      if (M) {
        ie(c.value !== void 0, "shouldScan watcher should only be triggered when component is mounted. Thus pause frame canvas is defined"), S(c.value), ie(d.value !== void 0, "shouldScan watcher should only be triggered when component is mounted. Thus tracking canvas is defined"), S(d.value);
        const A = () => a.track === void 0 ? 500 : 40;
        ie(h.value !== void 0, "shouldScan watcher should only be triggered when component is mounted. Thus video element is defined"), Qa(h.value, {
          detectHandler: (B) => i("detect", B),
          formats: a.formats,
          locateHandler: $,
          minDelay: A()
        });
      }
    });
    const S = (M) => {
      const A = M.getContext("2d");
      ie(A !== null, "canvas 2d context should always be non-null"), A.clearRect(0, 0, M.width, M.height);
    }, $ = (M) => {
      const A = d.value;
      ie(A !== void 0, "onLocate handler should only be called when component is mounted. Thus tracking canvas is always defined.");
      const B = h.value;
      if (ie(B !== void 0, "onLocate handler should only be called when component is mounted. Thus video element is always defined."), M.length === 0 || a.track === void 0)
        S(A);
      else {
        const ee = B.offsetWidth, W = B.offsetHeight, L = B.videoWidth, be = B.videoHeight, Te = Math.max(ee / L, W / be), Ee = L * Te, Oe = be * Te, je = Ee / L, We = Oe / be, Le = (ee - Ee) / 2, ut = (W - Oe) / 2, Me = ({ x: ue, y: J }) => ({
          x: Math.floor(ue * je),
          y: Math.floor(J * We)
        }), He = ({ x: ue, y: J }) => ({
          x: Math.floor(ue + Le),
          y: Math.floor(J + ut)
        }), ct = M.map((ue) => {
          const { boundingBox: J, cornerPoints: ve } = ue, { x: ft, y: dt } = He(
            Me({
              x: J.x,
              y: J.y
            })
          ), { x: Ce, y: pt } = Me({
            x: J.width,
            y: J.height
          });
          return {
            ...ue,
            cornerPoints: ve.map((Ve) => He(Me(Ve))),
            boundingBox: DOMRectReadOnly.fromRect({ x: ft, y: dt, width: Ce, height: pt })
          };
        });
        A.width = B.offsetWidth, A.height = B.offsetHeight;
        const lt = A.getContext("2d");
        a.track(ct, lt);
      }
    }, j = {
      width: "100%",
      height: "100%",
      position: "relative",
      // notice that we use z-index only once for the wrapper div.
      // If z-index is not defined, elements are stacked in the order they appear in the DOM.
      // The first element is at the very bottom and subsequent elements are added on top.
      "z-index": "0"
    }, U = {
      width: "100%",
      height: "100%",
      position: "absolute",
      top: "0",
      left: "0"
    }, O = {
      width: "100%",
      height: "100%",
      "object-fit": "cover"
    }, z = Et(() => _.value ? O : {
      ...O,
      visibility: "hidden",
      position: "absolute"
    });
    return (M, A) => (xt(), Rt("div", { style: j }, [
      tt("video", {
        ref_key: "videoRef",
        ref: h,
        style: wa(z.value),
        autoplay: "",
        muted: "",
        playsinline: ""
      }, null, 4),
      ba(tt("canvas", {
        id: "qrcode-stream-pause-frame",
        ref_key: "pauseFrameRef",
        ref: c,
        style: O
      }, null, 512), [
        [Ca, !_.value]
      ]),
      tt("canvas", {
        id: "qrcode-stream-tracking-layer",
        ref_key: "trackingLayerRef",
        ref: d,
        style: U
      }, null, 512),
      tt("div", { style: U }, [
        $r(M.$slots, "default")
      ])
    ]));
  }
}), xi = /* @__PURE__ */ Dt({
  __name: "QrcodeCapture",
  props: {
    formats: {
      type: Array,
      default: () => ["qr_code"]
    }
  },
  emits: ["detect"],
  setup(n, { emit: i }) {
    const a = n, c = (d) => {
      if (!(!(d.target instanceof HTMLInputElement) || !d.target.files))
        for (const h of Array.from(d.target.files))
          Ir(h, a.formats).then((v) => {
            i("detect", v);
          });
    };
    return (d, h) => (xt(), Rt("input", {
      onChange: c,
      type: "file",
      name: "image",
      accept: "image/*",
      capture: "environment",
      multiple: ""
    }, null, 32));
  }
}), Ri = ["onDrop"], ki = /* @__PURE__ */ Dt({
  __name: "QrcodeDropZone",
  props: {
    formats: {
      type: Array,
      default: () => ["qr_code"]
    }
  },
  emits: ["detect", "dragover", "error"],
  setup(n, { emit: i }) {
    const a = n, c = async (v) => {
      try {
        const w = await v;
        i("detect", w);
      } catch (w) {
        i("error", w);
      }
    }, d = (v) => {
      i("dragover", v);
    }, h = ({ dataTransfer: v }) => {
      if (!v)
        return;
      d(!1);
      const w = [...Array.from(v.files)], C = v.getData("text/uri-list");
      w.forEach((y) => {
        c(Ir(y));
      }), C !== "" && c(Za(C, a.formats));
    };
    return (v, w) => (xt(), Rt("div", {
      onDrop: rt(h, ["prevent", "stop"]),
      onDragenter: w[0] || (w[0] = rt((C) => d(!0), ["prevent", "stop"])),
      onDragleave: w[1] || (w[1] = rt((C) => d(!1), ["prevent", "stop"])),
      onDragover: w[2] || (w[2] = rt(() => {
      }, ["prevent", "stop"]))
    }, [
      $r(v.$slots, "default")
    ], 40, Ri));
  }
});
function Fi(n) {
  n.component("qrcode-stream", Di), n.component("qrcode-capture", xi), n.component("qrcode-drop-zone", ki);
}
const Ii = { install: Fi };
let it = null;
typeof window < "u" ? it = window.Vue : typeof global < "u" && (it = global.Vue);
it && it.use(Ii);
export {
  xi as QrcodeCapture,
  ki as QrcodeDropZone,
  Di as QrcodeStream,
  Ii as VueQrcodeReader,
  Fi as install,
  ji as setZXingModuleOverrides
};
